import{S as Dp,i as Pp,s as kp,e as a,k as d,w as x,t as i,M as Tp,c as r,d as t,m as f,a as s,x as D,h as n,b as u,N as $p,f as wp,G as e,g as _,y as P,q as k,o as T,B as A,v as Ap,L as xp}from"../../../chunks/vendor-hf-doc-builder.js";import{T as wt}from"../../../chunks/Tip-hf-doc-builder.js";import{D as J}from"../../../chunks/Docstring-hf-doc-builder.js";import{C as Ni}from"../../../chunks/CodeBlock-hf-doc-builder.js";import{I as zi}from"../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Ep}from"../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Cp(j){let l,y;return{c(){l=a("p"),y=i("This is an experimental feature and is likely to change in the future.")},l(g){l=r(g,"P",{});var v=s(l);y=n(v,"This is an experimental feature and is likely to change in the future."),v.forEach(t)},m(g,v){_(g,l,v),e(l,y)},d(g){g&&t(l)}}}function Ip(j){let l,y,g,v,$;return{c(){l=a("p"),y=i("It is required that the model repo has a file, called "),g=a("code"),v=i("pipeline.py"),$=i(` that defines the custom
pipeline.`)},l(c){l=r(c,"P",{});var b=s(l);y=n(b,"It is required that the model repo has a file, called "),g=r(b,"CODE",{});var C=s(g);v=n(C,"pipeline.py"),C.forEach(t),$=n(b,` that defines the custom
pipeline.`),b.forEach(t)},m(c,b){_(c,l,b),e(l,y),e(l,g),e(g,v),e(l,$)},d(c){c&&t(l)}}}function jp(j){let l,y,g,v,$;return{c(){l=a("p"),y=i("Community pipelines are always loaded from the current "),g=a("code"),v=i("main"),$=i(" branch of GitHub.")},l(c){l=r(c,"P",{});var b=s(l);y=n(b,"Community pipelines are always loaded from the current "),g=r(b,"CODE",{});var C=s(g);v=n(C,"main"),C.forEach(t),$=n(b," branch of GitHub."),b.forEach(t)},m(c,b){_(c,l,b),e(l,y),e(l,g),e(g,v),e(l,$)},d(c){c&&t(l)}}}function qp(j){let l,y,g,v,$;return{c(){l=a("p"),y=i("It is required that the directory has a file, called "),g=a("code"),v=i("pipeline.py"),$=i(` that defines the custom
pipeline.`)},l(c){l=r(c,"P",{});var b=s(l);y=n(b,"It is required that the directory has a file, called "),g=r(b,"CODE",{});var C=s(g);v=n(C,"pipeline.py"),C.forEach(t),$=n(b,` that defines the custom
pipeline.`),b.forEach(t)},m(c,b){_(c,l,b),e(l,y),e(l,g),e(g,v),e(l,$)},d(c){c&&t(l)}}}function Op(j){let l,y,g,v,$,c,b;return{c(){l=a("p"),y=i("It is required to be logged in ("),g=a("code"),v=i("huggingface-cli login"),$=i(") when you want to use private or "),c=a("a"),b=i(`gated
models`),this.h()},l(C){l=r(C,"P",{});var S=s(l);y=n(S,"It is required to be logged in ("),g=r(S,"CODE",{});var G=s(g);v=n(G,"huggingface-cli login"),G.forEach(t),$=n(S,") when you want to use private or "),c=r(S,"A",{href:!0,rel:!0});var L=s(c);b=n(L,`gated
models`),L.forEach(t),S.forEach(t),this.h()},h(){u(c,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),u(c,"rel","nofollow")},m(C,S){_(C,l,S),e(l,y),e(l,g),e(g,v),e(l,$),e(l,c),e(c,b)},d(C){C&&t(l)}}}function Sp(j){let l,y,g,v,$;return v=new Ni({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){l=a("p"),y=i("Examples:"),g=d(),x(v.$$.fragment)},l(c){l=r(c,"P",{});var b=s(l);y=n(b,"Examples:"),b.forEach(t),g=f(c),D(v.$$.fragment,c)},m(c,b){_(c,l,b),e(l,y),_(c,g,b),P(v,c,b),$=!0},p:xp,i(c){$||(k(v.$$.fragment,c),$=!0)},o(c){T(v.$$.fragment,c),$=!1},d(c){c&&t(l),c&&t(g),A(v,c)}}}function Mp(j){let l,y,g,v,$,c,b,C,S,G,L,K,z;return{c(){l=a("p"),y=i("It is required to be logged in ("),g=a("code"),v=i("huggingface-cli login"),$=i(") when you want to use private or "),c=a("a"),b=i(`gated
models`),C=i(", "),S=a("em"),G=i("e.g."),L=d(),K=a("code"),z=i('"runwayml/stable-diffusion-v1-5"'),this.h()},l(Q){l=r(Q,"P",{});var W=s(l);y=n(W,"It is required to be logged in ("),g=r(W,"CODE",{});var Oe=s(g);v=n(Oe,"huggingface-cli login"),Oe.forEach(t),$=n(W,") when you want to use private or "),c=r(W,"A",{href:!0,rel:!0});var N=s(c);b=n(N,`gated
models`),N.forEach(t),C=n(W,", "),S=r(W,"EM",{});var Et=s(S);G=n(Et,"e.g."),Et.forEach(t),L=f(W),K=r(W,"CODE",{});var X=s(K);z=n(X,'"runwayml/stable-diffusion-v1-5"'),X.forEach(t),W.forEach(t),this.h()},h(){u(c,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),u(c,"rel","nofollow")},m(Q,W){_(Q,l,W),e(l,y),e(l,g),e(g,v),e(l,$),e(l,c),e(c,b),e(l,C),e(l,S),e(S,G),e(l,L),e(l,K),e(K,z)},d(Q){Q&&t(l)}}}function Lp(j){let l,y,g,v,$;return{c(){l=a("p"),y=i("Activate the special "),g=a("a"),v=i("\u201Coffline-mode\u201D"),$=i(` to use
this method in a firewalled environment.`),this.h()},l(c){l=r(c,"P",{});var b=s(l);y=n(b,"Activate the special "),g=r(b,"A",{href:!0,rel:!0});var C=s(g);v=n(C,"\u201Coffline-mode\u201D"),C.forEach(t),$=n(b,` to use
this method in a firewalled environment.`),b.forEach(t),this.h()},h(){u(g,"href","https://huggingface.co/diffusers/installation.html#offline-mode"),u(g,"rel","nofollow")},m(c,b){_(c,l,b),e(l,y),e(l,g),e(g,v),e(l,$)},d(c){c&&t(l)}}}function Wp(j){let l,y,g,v,$;return v=new Ni({props:{code:`from diffusers import DiffusionPipeline

# Download pipeline from huggingface.co and cache.
pipeline = DiffusionPipeline.from_pretrained("CompVis/ldm-text2im-large-256")

# Download pipeline that requires an authorization token
# For more information on access tokens, please refer to this section
# of the documentation](https://huggingface.co/docs/hub/security-tokens)
pipeline = DiffusionPipeline.from_pretrained("runwayml/stable-diffusion-v1-5")

# Use a different scheduler
from diffusers import LMSDiscreteScheduler

scheduler = LMSDiscreteScheduler.from_config(pipeline.scheduler.config)
pipeline.scheduler = scheduler`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline from huggingface.co and cache.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;CompVis/ldm-text2im-large-256&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline that requires an authorization token</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># For more information on access tokens, please refer to this section</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># of the documentation](https://huggingface.co/docs/hub/security-tokens)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Use a different scheduler</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> LMSDiscreteScheduler

<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = LMSDiscreteScheduler.from_config(pipeline.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.scheduler = scheduler`}}),{c(){l=a("p"),y=i("Examples:"),g=d(),x(v.$$.fragment)},l(c){l=r(c,"P",{});var b=s(l);y=n(b,"Examples:"),b.forEach(t),g=f(c),D(v.$$.fragment,c)},m(c,b){_(c,l,b),e(l,y),_(c,g,b),P(v,c,b),$=!0},p:xp,i(c){$||(k(v.$$.fragment,c),$=!0)},o(c){T(v.$$.fragment,c),$=!1},d(c){c&&t(l),c&&t(g),A(v,c)}}}function Hp(j){let l,y,g,v,$,c,b,C,S,G,L,K,z,Q,W,Oe,N,Et,X,Mn,Ln,Ui,xt,Nt,Wn,Xi,Dt,Hn,Ri,R,Ut,Se,Vn,Fn,Xt,Me,Gn,zn,Rt,Nn,Yi,Z,le,Yt,Le,Un,Bt,Xn,Bi,de,Jt,ee,Kt,Rn,Yn,Qt,Bn,Jn,Pt,Kn,Qn,Zt,te,eo,We,Zn,ea,to,oo,ta,oa,kt,ia,Ji,oe,fe,io,He,na,no,aa,Ki,Tt,ra,Qi,Ve,Zi,At,sa,en,Ct,la,tn,Fe,on,pe,da,ao,fa,pa,nn,It,ca,an,Ge,rn,jt,ma,sn,qt,ze,ro,ce,ha,ua,ga,Ne,ld,_a,so,me,va,ba,ya,Ue,dd,ln,ie,he,lo,Xe,$a,fo,wa,dn,ue,po,Re,Ea,xa,co,Ye,Da,fn,ne,ge,mo,Be,Pa,ho,ka,pn,w,Je,Ta,uo,Aa,Ca,Ot,St,Ia,ja,qa,Ke,go,Oa,Sa,_o,Ma,La,vo,Wa,Ha,Qe,_e,bo,Va,Fa,yo,Ga,za,Na,ve,$o,Ua,Xa,wo,Ra,Ya,Ba,be,Ze,Ja,Eo,Ka,Qa,ye,et,Za,tt,er,xo,tr,or,ir,$e,ot,nr,Do,ar,rr,I,it,sr,Po,lr,dr,ae,fr,ko,pr,cr,To,mr,hr,ur,we,gr,Ao,_r,vr,re,nt,U,br,Co,yr,$r,at,wr,Er,Io,xr,Dr,Pr,Ee,kr,rt,H,Tr,jo,Ar,Cr,st,Ir,jr,qo,qr,Or,Oo,Sr,Mr,So,Lr,Wr,Hr,xe,Vr,lt,se,Fr,Mo,Gr,zr,Lo,Nr,Ur,Xr,De,Rr,Mt,Yr,dt,Br,Jr,p,Kr,Wo,Qr,Zr,Ho,es,ts,Vo,os,is,Fo,ns,as,Go,rs,ss,zo,ls,ds,No,fs,ps,Uo,cs,ms,Xo,hs,us,Ro,gs,_s,Yo,vs,bs,Bo,ys,$s,Jo,ws,Es,Ko,xs,Ds,Qo,Ps,ks,Zo,Ts,As,ei,Cs,Is,ti,js,qs,oi,Os,Ss,ii,Ms,Ls,ni,Ws,Hs,ai,Vs,Fs,ri,Gs,zs,si,Ns,Us,li,Xs,Rs,di,Ys,Bs,fi,Js,Ks,pi,Qs,Zs,ci,el,tl,mi,ol,il,hi,nl,al,ui,rl,sl,gi,ll,dl,_i,fl,pl,vi,cl,ml,bi,hl,ul,yi,gl,_l,$i,vl,bl,yl,Pe,$l,Y,ft,wl,wi,El,xl,Ei,Dl,Pl,V,pt,kl,xi,Tl,Al,Di,Cl,Il,Pi,jl,ql,ke,Ol,q,ct,Sl,ki,Ml,Ll,mt,Wl,Ti,Hl,Vl,Fl,ht,Gl,Ai,zl,Nl,Ul,ut,Xl,Ci,Rl,Yl,Bl,Te,Jl,Ae,Kl,Ce,Ql,Ie,gt,Zl,Ii,ed,td,je,_t,od,vt,id,ji,nd,ad,cn;return c=new zi({}),Le=new zi({}),He=new zi({}),Ve=new Ni({props:{code:`import torch
from diffusers import DiffusionPipeline
from diffusers.utils import export_to_video

pipe = DiffusionPipeline.from_pretrained("damo-vilab/text-to-video-ms-1.7b", torch_dtype=torch.float16, variant="fp16")
pipe = pipe.to("cuda")

prompt = "Spiderman is surfing"
video_frames = pipe(prompt).frames
video_path = export_to_video(video_frames)
video_path`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> export_to_video

pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;damo-vilab/text-to-video-ms-1.7b&quot;</span>, torch_dtype=torch.float16, variant=<span class="hljs-string">&quot;fp16&quot;</span>)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;Spiderman is surfing&quot;</span>
video_frames = pipe(prompt).frames
video_path = export_to_video(video_frames)
video_path`}}),Fe=new Ni({props:{code:`import torch
from diffusers import DiffusionPipeline
from diffusers.utils import export_to_video

pipe = DiffusionPipeline.from_pretrained("damo-vilab/text-to-video-ms-1.7b", torch_dtype=torch.float16, variant="fp16")
pipe.enable_model_cpu_offload()

# memory optimization
pipe.enable_vae_slicing()

prompt = "Darth Vader surfing a wave"
video_frames = pipe(prompt, num_frames=64).frames
video_path = export_to_video(video_frames)
video_path`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> export_to_video

pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;damo-vilab/text-to-video-ms-1.7b&quot;</span>, torch_dtype=torch.float16, variant=<span class="hljs-string">&quot;fp16&quot;</span>)
pipe.enable_model_cpu_offload()

<span class="hljs-comment"># memory optimization</span>
pipe.enable_vae_slicing()

prompt = <span class="hljs-string">&quot;Darth Vader surfing a wave&quot;</span>
video_frames = pipe(prompt, num_frames=<span class="hljs-number">64</span>).frames
video_path = export_to_video(video_frames)
video_path`}}),Ge=new Ni({props:{code:`import torch
from diffusers import DiffusionPipeline, DPMSolverMultistepScheduler
from diffusers.utils import export_to_video

pipe = DiffusionPipeline.from_pretrained("damo-vilab/text-to-video-ms-1.7b", torch_dtype=torch.float16, variant="fp16")
pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)
pipe.enable_model_cpu_offload()

prompt = "Spiderman is surfing"
video_frames = pipe(prompt, num_inference_steps=25).frames
video_path = export_to_video(video_frames)
video_path`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline, DPMSolverMultistepScheduler
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> export_to_video

pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;damo-vilab/text-to-video-ms-1.7b&quot;</span>, torch_dtype=torch.float16, variant=<span class="hljs-string">&quot;fp16&quot;</span>)
pipe.scheduler = DPMSolverMultistepScheduler.from_config(pipe.scheduler.config)
pipe.enable_model_cpu_offload()

prompt = <span class="hljs-string">&quot;Spiderman is surfing&quot;</span>
video_frames = pipe(prompt, num_inference_steps=<span class="hljs-number">25</span>).frames
video_path = export_to_video(video_frames)
video_path`}}),Xe=new zi({}),Be=new zi({}),Je=new J({props:{name:"class diffusers.DiffusionPipeline",anchor:"diffusers.DiffusionPipeline",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2697/src/diffusers/pipelines/pipeline_utils.py#L393"}}),Ze=new J({props:{name:"__call__",anchor:"diffusers.DiffusionPipeline.__call__",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}]}}),et=new J({props:{name:"disable_attention_slicing",anchor:"diffusers.DiffusionPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2697/src/diffusers/pipelines/pipeline_utils.py#L1370"}}),ot=new J({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.DiffusionPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2697/src/diffusers/pipelines/pipeline_utils.py#L1329"}}),it=new J({props:{name:"download",anchor:"diffusers.DiffusionPipeline.download",parameters:[{name:"pretrained_model_name",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.download.pretrained_model_name",description:`<strong>pretrained_model_name</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Should be a string, the <em>repo id</em> of a pretrained pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a> Valid repo ids have to be located under a user or organization name, like
<code>CompVis/ldm-text2im-large-256</code>.`,name:"pretrained_model_name"}],source:"https://github.com/huggingface/diffusers/blob/vr_2697/src/diffusers/pipelines/pipeline_utils.py#L980"}}),we=new wt({props:{warning:!0,$$slots:{default:[Cp]},$$scope:{ctx:j}}}),Ee=new wt({props:{$$slots:{default:[Ip]},$$scope:{ctx:j}}}),xe=new wt({props:{$$slots:{default:[jp]},$$scope:{ctx:j}}}),De=new wt({props:{$$slots:{default:[qp]},$$scope:{ctx:j}}}),Pe=new wt({props:{$$slots:{default:[Op]},$$scope:{ctx:j}}}),ft=new J({props:{name:"enable_attention_slicing",anchor:"diffusers.DiffusionPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2697/src/diffusers/pipelines/pipeline_utils.py#L1354"}}),pt=new J({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.DiffusionPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2697/src/diffusers/pipelines/pipeline_utils.py#L1297"}}),ke=new Ep({props:{anchor:"diffusers.DiffusionPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Sp]},$$scope:{ctx:j}}}),ct=new J({props:{name:"from_pretrained",anchor:"diffusers.DiffusionPipeline.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike, NoneType]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>repo id</em> of a pretrained pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a> Valid repo ids have to be located under a user or organization name, like
<code>CompVis/ldm-text2im-large-256</code>.</li>
<li>A path to a <em>directory</em> containing pipeline weights saved using
<a href="/docs/diffusers/pr_2697/en/api/pipelines/text_to_video#diffusers.DiffusionPipeline.save_pretrained">save_pretrained()</a>, e.g., <code>./my_pipeline_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.torch_dtype",description:`<strong>torch_dtype</strong> (<code>str</code> or <code>torch.dtype</code>, <em>optional</em>) &#x2014;
Override the default <code>torch.dtype</code> and load the model under this dtype. If <code>&quot;auto&quot;</code> is passed the dtype
will be automatically derived from the model&#x2019;s weights.`,name:"torch_dtype"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.custom_pipeline",description:`<strong>custom_pipeline</strong> (<code>str</code>, <em>optional</em>) &#x2014;</p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p>This is an experimental feature and is likely to change in the future.</p>

					</div>
<p>Can be either:</p>
<ul>
<li>
<p>A string, the <em>repo id</em> of a custom pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a>. Valid repo ids have to be located under a user or organization name,
like <code>hf-internal-testing/diffusers-dummy-pipeline</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>It is required that the model repo has a file, called <code>pipeline.py</code> that defines the custom
pipeline.</p>

					</div>
</li>
<li>
<p>A string, the <em>file name</em> of a community pipeline hosted on GitHub under
<a href="https://github.com/huggingface/diffusers/tree/main/examples/community" rel="nofollow">https://github.com/huggingface/diffusers/tree/main/examples/community</a>. Valid file names have to
match exactly the file name without <code>.py</code> located under the above link, <em>e.g.</em>
<code>clip_guided_stable_diffusion</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Community pipelines are always loaded from the current <code>main</code> branch of GitHub.</p>

					</div>
</li>
<li>
<p>A path to a <em>directory</em> containing a custom pipeline, e.g., <code>./my_pipeline_directory/</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>It is required that the directory has a file, called <code>pipeline.py</code> that defines the custom
pipeline.</p>

					</div>
</li>
</ul>
<p>For more information on how to load and create custom pipelines, please have a look at <a href="https://huggingface.co/docs/diffusers/using-diffusers/custom_pipeline_overview" rel="nofollow">Loading and
Adding Custom
Pipelines</a>`,name:"custom_pipeline"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.output_loading_info(bool,",description:`<strong>output_loading_info(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.`,name:"output_loading_info(bool,"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.custom_revision",description:`<strong>custom_revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code> when loading from the Hub and to local version of <code>diffusers</code> when loading from GitHub) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id similar to
<code>revision</code> when loading a custom pipeline from the Hub. It can be a diffusers version when loading a
custom pipeline from GitHub.`,name:"custom_revision"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information. specify the folder name here.`,name:"mirror"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.device_map",description:`<strong>device_map</strong> (<code>str</code> or <code>Dict[str, Union[int, str, torch.device]]</code>, <em>optional</em>) &#x2014;
A map that specifies where each submodule should go. It doesn&#x2019;t need to be refined to each
parameter/buffer name, once a given module name is inside, every submodule of it will be sent to the
same device.</p>
<p>To have Accelerate compute the most optimized <code>device_map</code> automatically, set <code>device_map=&quot;auto&quot;</code>. For
more information about each option see <a href="https://hf.co/docs/accelerate/main/en/usage_guides/big_modeling#designing-a-device-map" rel="nofollow">designing a device
map</a>.`,name:"device_map"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.low_cpu_mem_usage",description:`<strong>low_cpu_mem_usage</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code> if torch version &gt;= 1.9.0 else <code>False</code>) &#x2014;
Speed up model loading by not initializing the weights and only loading the pre-trained weights. This
also tries to not use more than 1x model size in CPU memory (including peak memory) while loading the
model. This is only supported when torch version &gt;= 1.9.0. If you are using an older version of torch,
setting this argument to <code>True</code> will raise an error.`,name:"low_cpu_mem_usage"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.use_safetensors",description:`<strong>use_safetensors</strong> (<code>bool</code>, <em>optional</em> ) &#x2014;
If set to <code>True</code>, the pipeline will be loaded from <code>safetensors</code> weights. If set to <code>None</code> (the
default). The pipeline will load using <code>safetensors</code> if the safetensors weights are available <em>and</em> if
<code>safetensors</code> is installed. If the to <code>False</code> the pipeline will <em>not</em> use <code>safetensors</code>.`,name:"use_safetensors"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.kwargs",description:`<strong>kwargs</strong> (remaining dictionary of keyword arguments, <em>optional</em>) &#x2014;
Can be used to overwrite load - and saveable variables - <em>i.e.</em> the pipeline components - of the
specific pipeline class. The overwritten components are then directly passed to the pipelines
<code>__init__</code> method. See example below for more information.`,name:"kwargs"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified load weights from <code>variant</code> filename, <em>e.g.</em> pytorch_model.<variant>.bin. <code>variant</code> is
ignored when using <code>from_flax</code>.</variant>`,name:"variant"}],source:"https://github.com/huggingface/diffusers/blob/vr_2697/src/diffusers/pipelines/pipeline_utils.py#L592"}}),Te=new wt({props:{$$slots:{default:[Mp]},$$scope:{ctx:j}}}),Ae=new wt({props:{$$slots:{default:[Lp]},$$scope:{ctx:j}}}),Ce=new Ep({props:{anchor:"diffusers.DiffusionPipeline.from_pretrained.example",$$slots:{default:[Wp]},$$scope:{ctx:j}}}),gt=new J({props:{name:"numpy_to_pil",anchor:"diffusers.DiffusionPipeline.numpy_to_pil",parameters:[{name:"images",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2697/src/diffusers/pipelines/pipeline_utils.py#L1263"}}),_t=new J({props:{name:"save_pretrained",anchor:"diffusers.DiffusionPipeline.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"safe_serialization",val:": bool = False"},{name:"variant",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.DiffusionPipeline.save_pretrained.safe_serialization",description:`<strong>safe_serialization</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to save the model using <code>safetensors</code> or the traditional PyTorch way (that uses <code>pickle</code>).`,name:"safe_serialization"},{anchor:"diffusers.DiffusionPipeline.save_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified, weights are saved in the format pytorch_model.<variant>.bin.</variant>`,name:"variant"}],source:"https://github.com/huggingface/diffusers/blob/vr_2697/src/diffusers/pipelines/pipeline_utils.py#L451"}}),{c(){l=a("meta"),y=d(),g=a("h1"),v=a("a"),$=a("span"),x(c.$$.fragment),b=d(),C=a("span"),S=i("Text-to-video synthesis"),G=d(),L=a("p"),K=i("Text-to-video synthesis from "),z=a("a"),Q=i("ModelScope"),W=i(" can be considered the same as Stable Diffusion structure-wise but it is extended to videos instead of static images. More specifically, this system allows us to generate videos from a natural language text prompt."),Oe=d(),N=a("p"),Et=i("From the "),X=a("a"),Mn=i("model summary"),Ln=i(":"),Ui=d(),xt=a("p"),Nt=a("em"),Wn=i("This model is based on a multi-stage text-to-video generation diffusion model, which inputs a description text and returns a video that matches the text description. Only English input is supported."),Xi=d(),Dt=a("p"),Hn=i("Resources:"),Ri=d(),R=a("ul"),Ut=a("li"),Se=a("a"),Vn=i("Website"),Fn=d(),Xt=a("li"),Me=a("a"),Gn=i("GitHub repository"),zn=d(),Rt=a("li"),Nn=i("[Spaces] (TODO)"),Yi=d(),Z=a("h2"),le=a("a"),Yt=a("span"),x(Le.$$.fragment),Un=d(),Bt=a("span"),Xn=i("Available Pipelines:"),Bi=d(),de=a("table"),Jt=a("thead"),ee=a("tr"),Kt=a("th"),Rn=i("Pipeline"),Yn=d(),Qt=a("th"),Bn=i("Tasks"),Jn=d(),Pt=a("th"),Kn=i("Demo"),Qn=d(),Zt=a("tbody"),te=a("tr"),eo=a("td"),We=a("a"),Zn=i("DiffusionPipeline"),ea=d(),to=a("td"),oo=a("em"),ta=i("Text-to-Video Generation"),oa=d(),kt=a("td"),ia=i("[Spaces] (TODO)"),Ji=d(),oe=a("h2"),fe=a("a"),io=a("span"),x(He.$$.fragment),na=d(),no=a("span"),aa=i("Usage example"),Ki=d(),Tt=a("p"),ra=i("Let\u2019s start by generating a short video with the default length of 16 frames (2s at 8 fps):"),Qi=d(),x(Ve.$$.fragment),Zi=d(),At=a("p"),sa=i(`Diffusers supports different optimization techniques to improve the latency
and memory footprint of a pipeline. Since videos are often more memory-heavy than images,
we can enable CPU offloading and VAE slicing to keep the memory footprint at bay.`),en=d(),Ct=a("p"),la=i("Let\u2019s generate a video of 8 seconds (64 frames) on the same GPU using CPU offloading and VAE slicing:"),tn=d(),x(Fe.$$.fragment),on=d(),pe=a("p"),da=i("It just takes "),ao=a("strong"),fa=i("7 GBs of GPU memory"),pa=i(" to generate the 64 video frames using PyTorch 2.0, \u201Cfp16\u201D precision and the techniques mentioned above."),nn=d(),It=a("p"),ca=i("We can also use a different scheduler easily, using the same method we\u2019d use for Stable Diffusion:"),an=d(),x(Ge.$$.fragment),rn=d(),jt=a("p"),ma=i("Here are some sample outputs:"),sn=d(),qt=a("table"),ze=a("tr"),ro=a("td"),ce=a("center"),ha=i(`An astronaut riding a horse.
        `),ua=a("br"),ga=d(),Ne=a("img"),_a=d(),so=a("td"),me=a("center"),va=i(`Darth vader surfing in waves.
        `),ba=a("br"),ya=d(),Ue=a("img"),ln=d(),ie=a("h2"),he=a("a"),lo=a("span"),x(Xe.$$.fragment),$a=d(),fo=a("span"),wa=i("Available checkpoints"),dn=d(),ue=a("ul"),po=a("li"),Re=a("a"),Ea=i("damo-vilab/text-to-video-ms-1.7b"),xa=d(),co=a("li"),Ye=a("a"),Da=i("damo-vilab/text-to-video-ms-1.7b-legacy"),fn=d(),ne=a("h2"),ge=a("a"),mo=a("span"),x(Be.$$.fragment),Pa=d(),ho=a("span"),ka=i("DiffusionPipeline"),pn=d(),w=a("div"),x(Je.$$.fragment),Ta=d(),uo=a("p"),Aa=i("Base class for all models."),Ca=d(),Ot=a("p"),St=a("a"),Ia=i("DiffusionPipeline"),ja=i(` takes care of storing all components (models, schedulers, processors) for diffusion pipelines
and handles methods for loading, downloading and saving models as well as a few methods common to all pipelines to:`),qa=d(),Ke=a("ul"),go=a("li"),Oa=i("move all PyTorch modules to the device of your choice"),Sa=d(),_o=a("li"),Ma=i("enabling/disabling the progress bar for the denoising iteration"),La=d(),vo=a("p"),Wa=i("Class attributes:"),Ha=d(),Qe=a("ul"),_e=a("li"),bo=a("strong"),Va=i("config_name"),Fa=i(" ("),yo=a("code"),Ga=i("str"),za=i(`) \u2014 name of the config file that will store the class and module names of all
components of the diffusion pipeline.`),Na=d(),ve=a("li"),$o=a("strong"),Ua=i("_optional_components"),Xa=i(" (List"),wo=a("code"),Ra=i("str"),Ya=i(`) \u2014 list of all components that are optional so they don\u2019t have to be
passed for the pipeline to function (should be overridden by subclasses).`),Ba=d(),be=a("div"),x(Ze.$$.fragment),Ja=d(),Eo=a("p"),Ka=i("Call self as a function."),Qa=d(),ye=a("div"),x(et.$$.fragment),Za=d(),tt=a("p"),er=i("Disable sliced attention computation. If "),xo=a("code"),tr=i("enable_attention_slicing"),or=i(` was previously invoked, this method will go
back to computing attention in one step.`),ir=d(),$e=a("div"),x(ot.$$.fragment),nr=d(),Do=a("p"),ar=i("Disable memory efficient attention as implemented in xformers."),rr=d(),I=a("div"),x(it.$$.fragment),sr=d(),Po=a("p"),lr=i("Download and cache a PyTorch diffusion pipeline from pre-trained pipeline weights."),dr=d(),ae=a("p"),fr=i("custom_pipeline ("),ko=a("code"),pr=i("str"),cr=i(", "),To=a("em"),mr=i("optional"),hr=i("):"),ur=d(),x(we.$$.fragment),gr=d(),Ao=a("p"),_r=i("Can be either:"),vr=d(),re=a("ul"),nt=a("li"),U=a("p"),br=i("A string, the "),Co=a("em"),yr=i("repo id"),$r=i(` of a custom pipeline hosted inside a model repo on
`),at=a("a"),wr=i("https://huggingface.co/"),Er=i(`. Valid repo ids have to be located under a user or organization name,
like `),Io=a("code"),xr=i("hf-internal-testing/diffusers-dummy-pipeline"),Dr=i("."),Pr=d(),x(Ee.$$.fragment),kr=d(),rt=a("li"),H=a("p"),Tr=i("A string, the "),jo=a("em"),Ar=i("file name"),Cr=i(` of a community pipeline hosted on GitHub under
`),st=a("a"),Ir=i("https://github.com/huggingface/diffusers/tree/main/examples/community"),jr=i(`. Valid file names have to
match exactly the file name without `),qo=a("code"),qr=i(".py"),Or=i(" located under the above link, "),Oo=a("em"),Sr=i("e.g."),Mr=d(),So=a("code"),Lr=i("clip_guided_stable_diffusion"),Wr=i("."),Hr=d(),x(xe.$$.fragment),Vr=d(),lt=a("li"),se=a("p"),Fr=i("A path to a "),Mo=a("em"),Gr=i("directory"),zr=i(" containing a custom pipeline, e.g., "),Lo=a("code"),Nr=i("./my_pipeline_directory/"),Ur=i("."),Xr=d(),x(De.$$.fragment),Rr=d(),Mt=a("p"),Yr=i("For more information on how to load and create custom pipelines, please have a look at "),dt=a("a"),Br=i(`Loading and
Adding Custom
Pipelines`),Jr=d(),p=a("p"),Kr=i("force_download ("),Wo=a("code"),Qr=i("bool"),Zr=i(", "),Ho=a("em"),es=i("optional"),ts=i(", defaults to "),Vo=a("code"),os=i("False"),is=i(`):
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.
resume_download (`),Fo=a("code"),ns=i("bool"),as=i(", "),Go=a("em"),rs=i("optional"),ss=i(", defaults to "),zo=a("code"),ls=i("False"),ds=i(`):
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.
proxies (`),No=a("code"),fs=i("Dict[str, str]"),ps=i(", "),Uo=a("em"),cs=i("optional"),ms=i(`):
A dictionary of proxy servers to use by protocol or endpoint, e.g., `),Xo=a("code"),hs=i("{'http': 'foo.bar:3128', 'http://hostname': 'foo.bar:4012'}"),us=i(`. The proxies are used on each request.
output_loading_info(`),Ro=a("code"),gs=i("bool"),_s=i(", "),Yo=a("em"),vs=i("optional"),bs=i(", defaults to "),Bo=a("code"),ys=i("False"),$s=i(`):
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.
local_files_only(`),Jo=a("code"),ws=i("bool"),Es=i(", "),Ko=a("em"),xs=i("optional"),Ds=i(", defaults to "),Qo=a("code"),Ps=i("False"),ks=i(`):
Whether or not to only look at local files (i.e., do not try to download the model).
use_auth_token (`),Zo=a("code"),Ts=i("str"),As=i(" or "),ei=a("em"),Cs=i("bool"),Is=i(", "),ti=a("em"),js=i("optional"),qs=i(`):
The token to use as HTTP bearer authorization for remote files. If `),oi=a("code"),Os=i("True"),Ss=i(`, will use the token generated
when running `),ii=a("code"),Ms=i("huggingface-cli login"),Ls=i(" (stored in "),ni=a("code"),Ws=i("~/.huggingface"),Hs=i(`).
revision (`),ai=a("code"),Vs=i("str"),Fs=i(", "),ri=a("em"),Gs=i("optional"),zs=i(", defaults to "),si=a("code"),Ns=i('"main"'),Us=i(`):
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so `),li=a("code"),Xs=i("revision"),Rs=i(` can be any
identifier allowed by git.
custom_revision (`),di=a("code"),Ys=i("str"),Bs=i(", "),fi=a("em"),Js=i("optional"),Ks=i(", defaults to "),pi=a("code"),Qs=i('"main"'),Zs=i(` when loading from the Hub and to local version of
`),ci=a("code"),el=i("diffusers"),tl=i(` when loading from GitHub):
The specific model version to use. It can be a branch name, a tag name, or a commit id similar to
`),mi=a("code"),ol=i("revision"),il=i(` when loading a custom pipeline from the Hub. It can be a diffusers version when loading a
custom pipeline from GitHub.
mirror (`),hi=a("code"),nl=i("str"),al=i(", "),ui=a("em"),rl=i("optional"),sl=i(`):
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information. specify the folder name here.
variant (`),gi=a("code"),ll=i("str"),dl=i(", "),_i=a("em"),fl=i("optional"),pl=i(`):
If specified load weights from `),vi=a("code"),cl=i("variant"),ml=i(" filename, "),bi=a("em"),hl=i("e.g."),ul=i(" pytorch_model.<variant>.bin. "),yi=a("code"),gl=i("variant"),_l=i(` is
ignored when using `),$i=a("code"),vl=i("from_flax"),bl=i("."),yl=d(),x(Pe.$$.fragment),$l=d(),Y=a("div"),x(ft.$$.fragment),wl=d(),wi=a("p"),El=i("Enable sliced attention computation."),xl=d(),Ei=a("p"),Dl=i(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Pl=d(),V=a("div"),x(pt.$$.fragment),kl=d(),xi=a("p"),Tl=i("Enable memory efficient attention as implemented in xformers."),Al=d(),Di=a("p"),Cl=i(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Il=d(),Pi=a("p"),jl=i(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),ql=d(),x(ke.$$.fragment),Ol=d(),q=a("div"),x(ct.$$.fragment),Sl=d(),ki=a("p"),Ml=i("Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights."),Ll=d(),mt=a("p"),Wl=i("The pipeline is set in evaluation mode by default using "),Ti=a("code"),Hl=i("model.eval()"),Vl=i(" (Dropout modules are deactivated)."),Fl=d(),ht=a("p"),Gl=i("The warning "),Ai=a("em"),zl=i("Weights from XXX not initialized from pretrained model"),Nl=i(` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),Ul=d(),ut=a("p"),Xl=i("The warning "),Ci=a("em"),Rl=i("Weights from XXX not used in YYY"),Yl=i(` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),Bl=d(),x(Te.$$.fragment),Jl=d(),x(Ae.$$.fragment),Kl=d(),x(Ce.$$.fragment),Ql=d(),Ie=a("div"),x(gt.$$.fragment),Zl=d(),Ii=a("p"),ed=i("Convert a numpy image or a batch of images to a PIL image."),td=d(),je=a("div"),x(_t.$$.fragment),od=d(),vt=a("p"),id=i(`Save all variables of the pipeline that can be saved and loaded as well as the pipelines configuration file to
a directory. A pipeline variable can be saved and loaded if its class implements both a save and loading
method. The pipeline can easily be re-loaded using the `),ji=a("code"),nd=i("[from_pretrained()](/docs/diffusers/pr_2697/en/api/pipelines/text_to_video#diffusers.DiffusionPipeline.from_pretrained)"),ad=i(" class method."),this.h()},l(o){const h=Tp('[data-svelte="svelte-1phssyn"]',document.head);l=r(h,"META",{name:!0,content:!0}),h.forEach(t),y=f(o),g=r(o,"H1",{class:!0});var bt=s(g);v=r(bt,"A",{id:!0,class:!0,href:!0});var qi=s(v);$=r(qi,"SPAN",{});var Oi=s($);D(c.$$.fragment,Oi),Oi.forEach(t),qi.forEach(t),b=f(bt),C=r(bt,"SPAN",{});var Si=s(C);S=n(Si,"Text-to-video synthesis"),Si.forEach(t),bt.forEach(t),G=f(o),L=r(o,"P",{});var yt=s(L);K=n(yt,"Text-to-video synthesis from "),z=r(yt,"A",{href:!0,rel:!0});var Mi=s(z);Q=n(Mi,"ModelScope"),Mi.forEach(t),W=n(yt," can be considered the same as Stable Diffusion structure-wise but it is extended to videos instead of static images. More specifically, this system allows us to generate videos from a natural language text prompt."),yt.forEach(t),Oe=f(o),N=r(o,"P",{});var $t=s(N);Et=n($t,"From the "),X=r($t,"A",{href:!0,rel:!0});var Li=s(X);Mn=n(Li,"model summary"),Li.forEach(t),Ln=n($t,":"),$t.forEach(t),Ui=f(o),xt=r(o,"P",{});var Wi=s(xt);Nt=r(Wi,"EM",{});var fd=s(Nt);Wn=n(fd,"This model is based on a multi-stage text-to-video generation diffusion model, which inputs a description text and returns a video that matches the text description. Only English input is supported."),fd.forEach(t),Wi.forEach(t),Xi=f(o),Dt=r(o,"P",{});var pd=s(Dt);Hn=n(pd,"Resources:"),pd.forEach(t),Ri=f(o),R=r(o,"UL",{});var Lt=s(R);Ut=r(Lt,"LI",{});var cd=s(Ut);Se=r(cd,"A",{href:!0,rel:!0});var md=s(Se);Vn=n(md,"Website"),md.forEach(t),cd.forEach(t),Fn=f(Lt),Xt=r(Lt,"LI",{});var hd=s(Xt);Me=r(hd,"A",{href:!0,rel:!0});var ud=s(Me);Gn=n(ud,"GitHub repository"),ud.forEach(t),hd.forEach(t),zn=f(Lt),Rt=r(Lt,"LI",{});var gd=s(Rt);Nn=n(gd,"[Spaces] (TODO)"),gd.forEach(t),Lt.forEach(t),Yi=f(o),Z=r(o,"H2",{class:!0});var mn=s(Z);le=r(mn,"A",{id:!0,class:!0,href:!0});var _d=s(le);Yt=r(_d,"SPAN",{});var vd=s(Yt);D(Le.$$.fragment,vd),vd.forEach(t),_d.forEach(t),Un=f(mn),Bt=r(mn,"SPAN",{});var bd=s(Bt);Xn=n(bd,"Available Pipelines:"),bd.forEach(t),mn.forEach(t),Bi=f(o),de=r(o,"TABLE",{});var hn=s(de);Jt=r(hn,"THEAD",{});var yd=s(Jt);ee=r(yd,"TR",{});var Wt=s(ee);Kt=r(Wt,"TH",{});var $d=s(Kt);Rn=n($d,"Pipeline"),$d.forEach(t),Yn=f(Wt),Qt=r(Wt,"TH",{});var wd=s(Qt);Bn=n(wd,"Tasks"),wd.forEach(t),Jn=f(Wt),Pt=r(Wt,"TH",{align:!0});var Ed=s(Pt);Kn=n(Ed,"Demo"),Ed.forEach(t),Wt.forEach(t),yd.forEach(t),Qn=f(hn),Zt=r(hn,"TBODY",{});var xd=s(Zt);te=r(xd,"TR",{});var Ht=s(te);eo=r(Ht,"TD",{});var Dd=s(eo);We=r(Dd,"A",{href:!0,rel:!0});var Pd=s(We);Zn=n(Pd,"DiffusionPipeline"),Pd.forEach(t),Dd.forEach(t),ea=f(Ht),to=r(Ht,"TD",{});var kd=s(to);oo=r(kd,"EM",{});var Td=s(oo);ta=n(Td,"Text-to-Video Generation"),Td.forEach(t),kd.forEach(t),oa=f(Ht),kt=r(Ht,"TD",{align:!0});var Ad=s(kt);ia=n(Ad,"[Spaces] (TODO)"),Ad.forEach(t),Ht.forEach(t),xd.forEach(t),hn.forEach(t),Ji=f(o),oe=r(o,"H2",{class:!0});var un=s(oe);fe=r(un,"A",{id:!0,class:!0,href:!0});var Cd=s(fe);io=r(Cd,"SPAN",{});var Id=s(io);D(He.$$.fragment,Id),Id.forEach(t),Cd.forEach(t),na=f(un),no=r(un,"SPAN",{});var jd=s(no);aa=n(jd,"Usage example"),jd.forEach(t),un.forEach(t),Ki=f(o),Tt=r(o,"P",{});var qd=s(Tt);ra=n(qd,"Let\u2019s start by generating a short video with the default length of 16 frames (2s at 8 fps):"),qd.forEach(t),Qi=f(o),D(Ve.$$.fragment,o),Zi=f(o),At=r(o,"P",{});var Od=s(At);sa=n(Od,`Diffusers supports different optimization techniques to improve the latency
and memory footprint of a pipeline. Since videos are often more memory-heavy than images,
we can enable CPU offloading and VAE slicing to keep the memory footprint at bay.`),Od.forEach(t),en=f(o),Ct=r(o,"P",{});var Sd=s(Ct);la=n(Sd,"Let\u2019s generate a video of 8 seconds (64 frames) on the same GPU using CPU offloading and VAE slicing:"),Sd.forEach(t),tn=f(o),D(Fe.$$.fragment,o),on=f(o),pe=r(o,"P",{});var gn=s(pe);da=n(gn,"It just takes "),ao=r(gn,"STRONG",{});var Md=s(ao);fa=n(Md,"7 GBs of GPU memory"),Md.forEach(t),pa=n(gn," to generate the 64 video frames using PyTorch 2.0, \u201Cfp16\u201D precision and the techniques mentioned above."),gn.forEach(t),nn=f(o),It=r(o,"P",{});var Ld=s(It);ca=n(Ld,"We can also use a different scheduler easily, using the same method we\u2019d use for Stable Diffusion:"),Ld.forEach(t),an=f(o),D(Ge.$$.fragment,o),rn=f(o),jt=r(o,"P",{});var Wd=s(jt);ma=n(Wd,"Here are some sample outputs:"),Wd.forEach(t),sn=f(o),qt=r(o,"TABLE",{});var Hd=s(qt);ze=r(Hd,"TR",{});var _n=s(ze);ro=r(_n,"TD",{});var Vd=s(ro);ce=r(Vd,"CENTER",{});var Hi=s(ce);ha=n(Hi,`An astronaut riding a horse.
        `),ua=r(Hi,"BR",{}),ga=f(Hi),Ne=r(Hi,"IMG",{src:!0,alt:!0,style:!0}),Hi.forEach(t),Vd.forEach(t),_a=f(_n),so=r(_n,"TD",{});var Fd=s(so);me=r(Fd,"CENTER",{});var Vi=s(me);va=n(Vi,`Darth vader surfing in waves.
        `),ba=r(Vi,"BR",{}),ya=f(Vi),Ue=r(Vi,"IMG",{src:!0,alt:!0,style:!0}),Vi.forEach(t),Fd.forEach(t),_n.forEach(t),Hd.forEach(t),ln=f(o),ie=r(o,"H2",{class:!0});var vn=s(ie);he=r(vn,"A",{id:!0,class:!0,href:!0});var Gd=s(he);lo=r(Gd,"SPAN",{});var zd=s(lo);D(Xe.$$.fragment,zd),zd.forEach(t),Gd.forEach(t),$a=f(vn),fo=r(vn,"SPAN",{});var Nd=s(fo);wa=n(Nd,"Available checkpoints"),Nd.forEach(t),vn.forEach(t),dn=f(o),ue=r(o,"UL",{});var bn=s(ue);po=r(bn,"LI",{});var Ud=s(po);Re=r(Ud,"A",{href:!0,rel:!0});var Xd=s(Re);Ea=n(Xd,"damo-vilab/text-to-video-ms-1.7b"),Xd.forEach(t),Ud.forEach(t),xa=f(bn),co=r(bn,"LI",{});var Rd=s(co);Ye=r(Rd,"A",{href:!0,rel:!0});var Yd=s(Ye);Da=n(Yd,"damo-vilab/text-to-video-ms-1.7b-legacy"),Yd.forEach(t),Rd.forEach(t),bn.forEach(t),fn=f(o),ne=r(o,"H2",{class:!0});var yn=s(ne);ge=r(yn,"A",{id:!0,class:!0,href:!0});var Bd=s(ge);mo=r(Bd,"SPAN",{});var Jd=s(mo);D(Be.$$.fragment,Jd),Jd.forEach(t),Bd.forEach(t),Pa=f(yn),ho=r(yn,"SPAN",{});var Kd=s(ho);ka=n(Kd,"DiffusionPipeline"),Kd.forEach(t),yn.forEach(t),pn=f(o),w=r(o,"DIV",{class:!0});var E=s(w);D(Je.$$.fragment,E),Ta=f(E),uo=r(E,"P",{});var Qd=s(uo);Aa=n(Qd,"Base class for all models."),Qd.forEach(t),Ca=f(E),Ot=r(E,"P",{});var rd=s(Ot);St=r(rd,"A",{href:!0});var Zd=s(St);Ia=n(Zd,"DiffusionPipeline"),Zd.forEach(t),ja=n(rd,` takes care of storing all components (models, schedulers, processors) for diffusion pipelines
and handles methods for loading, downloading and saving models as well as a few methods common to all pipelines to:`),rd.forEach(t),qa=f(E),Ke=r(E,"UL",{});var $n=s(Ke);go=r($n,"LI",{});var ef=s(go);Oa=n(ef,"move all PyTorch modules to the device of your choice"),ef.forEach(t),Sa=f($n),_o=r($n,"LI",{});var tf=s(_o);Ma=n(tf,"enabling/disabling the progress bar for the denoising iteration"),tf.forEach(t),$n.forEach(t),La=f(E),vo=r(E,"P",{});var of=s(vo);Wa=n(of,"Class attributes:"),of.forEach(t),Ha=f(E),Qe=r(E,"UL",{});var wn=s(Qe);_e=r(wn,"LI",{});var Fi=s(_e);bo=r(Fi,"STRONG",{});var nf=s(bo);Va=n(nf,"config_name"),nf.forEach(t),Fa=n(Fi," ("),yo=r(Fi,"CODE",{});var af=s(yo);Ga=n(af,"str"),af.forEach(t),za=n(Fi,`) \u2014 name of the config file that will store the class and module names of all
components of the diffusion pipeline.`),Fi.forEach(t),Na=f(wn),ve=r(wn,"LI",{});var Gi=s(ve);$o=r(Gi,"STRONG",{});var rf=s($o);Ua=n(rf,"_optional_components"),rf.forEach(t),Xa=n(Gi," (List"),wo=r(Gi,"CODE",{});var sf=s(wo);Ra=n(sf,"str"),sf.forEach(t),Ya=n(Gi,`) \u2014 list of all components that are optional so they don\u2019t have to be
passed for the pipeline to function (should be overridden by subclasses).`),Gi.forEach(t),wn.forEach(t),Ba=f(E),be=r(E,"DIV",{class:!0});var En=s(be);D(Ze.$$.fragment,En),Ja=f(En),Eo=r(En,"P",{});var lf=s(Eo);Ka=n(lf,"Call self as a function."),lf.forEach(t),En.forEach(t),Qa=f(E),ye=r(E,"DIV",{class:!0});var xn=s(ye);D(et.$$.fragment,xn),Za=f(xn),tt=r(xn,"P",{});var Dn=s(tt);er=n(Dn,"Disable sliced attention computation. If "),xo=r(Dn,"CODE",{});var df=s(xo);tr=n(df,"enable_attention_slicing"),df.forEach(t),or=n(Dn,` was previously invoked, this method will go
back to computing attention in one step.`),Dn.forEach(t),xn.forEach(t),ir=f(E),$e=r(E,"DIV",{class:!0});var Pn=s($e);D(ot.$$.fragment,Pn),nr=f(Pn),Do=r(Pn,"P",{});var ff=s(Do);ar=n(ff,"Disable memory efficient attention as implemented in xformers."),ff.forEach(t),Pn.forEach(t),rr=f(E),I=r(E,"DIV",{class:!0});var O=s(I);D(it.$$.fragment,O),sr=f(O),Po=r(O,"P",{});var pf=s(Po);lr=n(pf,"Download and cache a PyTorch diffusion pipeline from pre-trained pipeline weights."),pf.forEach(t),dr=f(O),ae=r(O,"P",{});var Vt=s(ae);fr=n(Vt,"custom_pipeline ("),ko=r(Vt,"CODE",{});var cf=s(ko);pr=n(cf,"str"),cf.forEach(t),cr=n(Vt,", "),To=r(Vt,"EM",{});var mf=s(To);mr=n(mf,"optional"),mf.forEach(t),hr=n(Vt,"):"),Vt.forEach(t),ur=f(O),D(we.$$.fragment,O),gr=f(O),Ao=r(O,"P",{});var hf=s(Ao);_r=n(hf,"Can be either:"),hf.forEach(t),vr=f(O),re=r(O,"UL",{});var Ft=s(re);nt=r(Ft,"LI",{});var kn=s(nt);U=r(kn,"P",{});var qe=s(U);br=n(qe,"A string, the "),Co=r(qe,"EM",{});var uf=s(Co);yr=n(uf,"repo id"),uf.forEach(t),$r=n(qe,` of a custom pipeline hosted inside a model repo on
`),at=r(qe,"A",{href:!0,rel:!0});var gf=s(at);wr=n(gf,"https://huggingface.co/"),gf.forEach(t),Er=n(qe,`. Valid repo ids have to be located under a user or organization name,
like `),Io=r(qe,"CODE",{});var _f=s(Io);xr=n(_f,"hf-internal-testing/diffusers-dummy-pipeline"),_f.forEach(t),Dr=n(qe,"."),qe.forEach(t),Pr=f(kn),D(Ee.$$.fragment,kn),kn.forEach(t),kr=f(Ft),rt=r(Ft,"LI",{});var Tn=s(rt);H=r(Tn,"P",{});var F=s(H);Tr=n(F,"A string, the "),jo=r(F,"EM",{});var vf=s(jo);Ar=n(vf,"file name"),vf.forEach(t),Cr=n(F,` of a community pipeline hosted on GitHub under
`),st=r(F,"A",{href:!0,rel:!0});var bf=s(st);Ir=n(bf,"https://github.com/huggingface/diffusers/tree/main/examples/community"),bf.forEach(t),jr=n(F,`. Valid file names have to
match exactly the file name without `),qo=r(F,"CODE",{});var yf=s(qo);qr=n(yf,".py"),yf.forEach(t),Or=n(F," located under the above link, "),Oo=r(F,"EM",{});var $f=s(Oo);Sr=n($f,"e.g."),$f.forEach(t),Mr=f(F),So=r(F,"CODE",{});var wf=s(So);Lr=n(wf,"clip_guided_stable_diffusion"),wf.forEach(t),Wr=n(F,"."),F.forEach(t),Hr=f(Tn),D(xe.$$.fragment,Tn),Tn.forEach(t),Vr=f(Ft),lt=r(Ft,"LI",{});var An=s(lt);se=r(An,"P",{});var Gt=s(se);Fr=n(Gt,"A path to a "),Mo=r(Gt,"EM",{});var Ef=s(Mo);Gr=n(Ef,"directory"),Ef.forEach(t),zr=n(Gt," containing a custom pipeline, e.g., "),Lo=r(Gt,"CODE",{});var xf=s(Lo);Nr=n(xf,"./my_pipeline_directory/"),xf.forEach(t),Ur=n(Gt,"."),Gt.forEach(t),Xr=f(An),D(De.$$.fragment,An),An.forEach(t),Ft.forEach(t),Rr=f(O),Mt=r(O,"P",{});var sd=s(Mt);Yr=n(sd,"For more information on how to load and create custom pipelines, please have a look at "),dt=r(sd,"A",{href:!0,rel:!0});var Df=s(dt);Br=n(Df,`Loading and
Adding Custom
Pipelines`),Df.forEach(t),sd.forEach(t),Jr=f(O),p=r(O,"P",{});var m=s(p);Kr=n(m,"force_download ("),Wo=r(m,"CODE",{});var Pf=s(Wo);Qr=n(Pf,"bool"),Pf.forEach(t),Zr=n(m,", "),Ho=r(m,"EM",{});var kf=s(Ho);es=n(kf,"optional"),kf.forEach(t),ts=n(m,", defaults to "),Vo=r(m,"CODE",{});var Tf=s(Vo);os=n(Tf,"False"),Tf.forEach(t),is=n(m,`):
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.
resume_download (`),Fo=r(m,"CODE",{});var Af=s(Fo);ns=n(Af,"bool"),Af.forEach(t),as=n(m,", "),Go=r(m,"EM",{});var Cf=s(Go);rs=n(Cf,"optional"),Cf.forEach(t),ss=n(m,", defaults to "),zo=r(m,"CODE",{});var If=s(zo);ls=n(If,"False"),If.forEach(t),ds=n(m,`):
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.
proxies (`),No=r(m,"CODE",{});var jf=s(No);fs=n(jf,"Dict[str, str]"),jf.forEach(t),ps=n(m,", "),Uo=r(m,"EM",{});var qf=s(Uo);cs=n(qf,"optional"),qf.forEach(t),ms=n(m,`):
A dictionary of proxy servers to use by protocol or endpoint, e.g., `),Xo=r(m,"CODE",{});var Of=s(Xo);hs=n(Of,"{'http': 'foo.bar:3128', 'http://hostname': 'foo.bar:4012'}"),Of.forEach(t),us=n(m,`. The proxies are used on each request.
output_loading_info(`),Ro=r(m,"CODE",{});var Sf=s(Ro);gs=n(Sf,"bool"),Sf.forEach(t),_s=n(m,", "),Yo=r(m,"EM",{});var Mf=s(Yo);vs=n(Mf,"optional"),Mf.forEach(t),bs=n(m,", defaults to "),Bo=r(m,"CODE",{});var Lf=s(Bo);ys=n(Lf,"False"),Lf.forEach(t),$s=n(m,`):
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.
local_files_only(`),Jo=r(m,"CODE",{});var Wf=s(Jo);ws=n(Wf,"bool"),Wf.forEach(t),Es=n(m,", "),Ko=r(m,"EM",{});var Hf=s(Ko);xs=n(Hf,"optional"),Hf.forEach(t),Ds=n(m,", defaults to "),Qo=r(m,"CODE",{});var Vf=s(Qo);Ps=n(Vf,"False"),Vf.forEach(t),ks=n(m,`):
Whether or not to only look at local files (i.e., do not try to download the model).
use_auth_token (`),Zo=r(m,"CODE",{});var Ff=s(Zo);Ts=n(Ff,"str"),Ff.forEach(t),As=n(m," or "),ei=r(m,"EM",{});var Gf=s(ei);Cs=n(Gf,"bool"),Gf.forEach(t),Is=n(m,", "),ti=r(m,"EM",{});var zf=s(ti);js=n(zf,"optional"),zf.forEach(t),qs=n(m,`):
The token to use as HTTP bearer authorization for remote files. If `),oi=r(m,"CODE",{});var Nf=s(oi);Os=n(Nf,"True"),Nf.forEach(t),Ss=n(m,`, will use the token generated
when running `),ii=r(m,"CODE",{});var Uf=s(ii);Ms=n(Uf,"huggingface-cli login"),Uf.forEach(t),Ls=n(m," (stored in "),ni=r(m,"CODE",{});var Xf=s(ni);Ws=n(Xf,"~/.huggingface"),Xf.forEach(t),Hs=n(m,`).
revision (`),ai=r(m,"CODE",{});var Rf=s(ai);Vs=n(Rf,"str"),Rf.forEach(t),Fs=n(m,", "),ri=r(m,"EM",{});var Yf=s(ri);Gs=n(Yf,"optional"),Yf.forEach(t),zs=n(m,", defaults to "),si=r(m,"CODE",{});var Bf=s(si);Ns=n(Bf,'"main"'),Bf.forEach(t),Us=n(m,`):
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so `),li=r(m,"CODE",{});var Jf=s(li);Xs=n(Jf,"revision"),Jf.forEach(t),Rs=n(m,` can be any
identifier allowed by git.
custom_revision (`),di=r(m,"CODE",{});var Kf=s(di);Ys=n(Kf,"str"),Kf.forEach(t),Bs=n(m,", "),fi=r(m,"EM",{});var Qf=s(fi);Js=n(Qf,"optional"),Qf.forEach(t),Ks=n(m,", defaults to "),pi=r(m,"CODE",{});var Zf=s(pi);Qs=n(Zf,'"main"'),Zf.forEach(t),Zs=n(m,` when loading from the Hub and to local version of
`),ci=r(m,"CODE",{});var ep=s(ci);el=n(ep,"diffusers"),ep.forEach(t),tl=n(m,` when loading from GitHub):
The specific model version to use. It can be a branch name, a tag name, or a commit id similar to
`),mi=r(m,"CODE",{});var tp=s(mi);ol=n(tp,"revision"),tp.forEach(t),il=n(m,` when loading a custom pipeline from the Hub. It can be a diffusers version when loading a
custom pipeline from GitHub.
mirror (`),hi=r(m,"CODE",{});var op=s(hi);nl=n(op,"str"),op.forEach(t),al=n(m,", "),ui=r(m,"EM",{});var ip=s(ui);rl=n(ip,"optional"),ip.forEach(t),sl=n(m,`):
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information. specify the folder name here.
variant (`),gi=r(m,"CODE",{});var np=s(gi);ll=n(np,"str"),np.forEach(t),dl=n(m,", "),_i=r(m,"EM",{});var ap=s(_i);fl=n(ap,"optional"),ap.forEach(t),pl=n(m,`):
If specified load weights from `),vi=r(m,"CODE",{});var rp=s(vi);cl=n(rp,"variant"),rp.forEach(t),ml=n(m," filename, "),bi=r(m,"EM",{});var sp=s(bi);hl=n(sp,"e.g."),sp.forEach(t),ul=n(m," pytorch_model.<variant>.bin. "),yi=r(m,"CODE",{});var lp=s(yi);gl=n(lp,"variant"),lp.forEach(t),_l=n(m,` is
ignored when using `),$i=r(m,"CODE",{});var dp=s($i);vl=n(dp,"from_flax"),dp.forEach(t),bl=n(m,"."),m.forEach(t),yl=f(O),D(Pe.$$.fragment,O),O.forEach(t),$l=f(E),Y=r(E,"DIV",{class:!0});var zt=s(Y);D(ft.$$.fragment,zt),wl=f(zt),wi=r(zt,"P",{});var fp=s(wi);El=n(fp,"Enable sliced attention computation."),fp.forEach(t),xl=f(zt),Ei=r(zt,"P",{});var pp=s(Ei);Dl=n(pp,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),pp.forEach(t),zt.forEach(t),Pl=f(E),V=r(E,"DIV",{class:!0});var B=s(V);D(pt.$$.fragment,B),kl=f(B),xi=r(B,"P",{});var cp=s(xi);Tl=n(cp,"Enable memory efficient attention as implemented in xformers."),cp.forEach(t),Al=f(B),Di=r(B,"P",{});var mp=s(Di);Cl=n(mp,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),mp.forEach(t),Il=f(B),Pi=r(B,"P",{});var hp=s(Pi);jl=n(hp,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),hp.forEach(t),ql=f(B),D(ke.$$.fragment,B),B.forEach(t),Ol=f(E),q=r(E,"DIV",{class:!0});var M=s(q);D(ct.$$.fragment,M),Sl=f(M),ki=r(M,"P",{});var up=s(ki);Ml=n(up,"Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights."),up.forEach(t),Ll=f(M),mt=r(M,"P",{});var Cn=s(mt);Wl=n(Cn,"The pipeline is set in evaluation mode by default using "),Ti=r(Cn,"CODE",{});var gp=s(Ti);Hl=n(gp,"model.eval()"),gp.forEach(t),Vl=n(Cn," (Dropout modules are deactivated)."),Cn.forEach(t),Fl=f(M),ht=r(M,"P",{});var In=s(ht);Gl=n(In,"The warning "),Ai=r(In,"EM",{});var _p=s(Ai);zl=n(_p,"Weights from XXX not initialized from pretrained model"),_p.forEach(t),Nl=n(In,` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),In.forEach(t),Ul=f(M),ut=r(M,"P",{});var jn=s(ut);Xl=n(jn,"The warning "),Ci=r(jn,"EM",{});var vp=s(Ci);Rl=n(vp,"Weights from XXX not used in YYY"),vp.forEach(t),Yl=n(jn,` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),jn.forEach(t),Bl=f(M),D(Te.$$.fragment,M),Jl=f(M),D(Ae.$$.fragment,M),Kl=f(M),D(Ce.$$.fragment,M),M.forEach(t),Ql=f(E),Ie=r(E,"DIV",{class:!0});var qn=s(Ie);D(gt.$$.fragment,qn),Zl=f(qn),Ii=r(qn,"P",{});var bp=s(Ii);ed=n(bp,"Convert a numpy image or a batch of images to a PIL image."),bp.forEach(t),qn.forEach(t),td=f(E),je=r(E,"DIV",{class:!0});var On=s(je);D(_t.$$.fragment,On),od=f(On),vt=r(On,"P",{});var Sn=s(vt);id=n(Sn,`Save all variables of the pipeline that can be saved and loaded as well as the pipelines configuration file to
a directory. A pipeline variable can be saved and loaded if its class implements both a save and loading
method. The pipeline can easily be re-loaded using the `),ji=r(Sn,"CODE",{});var yp=s(ji);nd=n(yp,"[from_pretrained()](/docs/diffusers/pr_2697/en/api/pipelines/text_to_video#diffusers.DiffusionPipeline.from_pretrained)"),yp.forEach(t),ad=n(Sn," class method."),Sn.forEach(t),On.forEach(t),E.forEach(t),this.h()},h(){u(l,"name","hf:doc:metadata"),u(l,"content",JSON.stringify(Vp)),u(v,"id","texttovideo-synthesis"),u(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(v,"href","#texttovideo-synthesis"),u(g,"class","relative group"),u(z,"href","https://modelscope.cn/"),u(z,"rel","nofollow"),u(X,"href","https://huggingface.co/damo-vilab/modelscope-damo-text-to-video-synthesis"),u(X,"rel","nofollow"),u(Se,"href","https://modelscope.cn/models/damo/text-to-video-synthesis/summary"),u(Se,"rel","nofollow"),u(Me,"href","https://github.com/modelscope/modelscope/"),u(Me,"rel","nofollow"),u(le,"id","available-pipelines"),u(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(le,"href","#available-pipelines"),u(Z,"class","relative group"),u(Pt,"align","center"),u(We,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/text_to_video_synthesis/pipeline_text_to_video_synth.py"),u(We,"rel","nofollow"),u(kt,"align","center"),u(fe,"id","usage-example"),u(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(fe,"href","#usage-example"),u(oe,"class","relative group"),$p(Ne.src,ld="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/astr.gif")||u(Ne,"src",ld),u(Ne,"alt","An astronaut riding a horse."),wp(Ne,"width","300px"),$p(Ue.src,dd="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vader.gif")||u(Ue,"src",dd),u(Ue,"alt","Darth vader surfing in waves."),wp(Ue,"width","300px"),u(he,"id","available-checkpoints"),u(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(he,"href","#available-checkpoints"),u(ie,"class","relative group"),u(Re,"href","https://huggingface.co/damo-vilab/text-to-video-ms-1.7b/"),u(Re,"rel","nofollow"),u(Ye,"href","https://huggingface.co/damo-vilab/text-to-video-ms-1.7b-legacy"),u(Ye,"rel","nofollow"),u(ge,"id","diffusers.DiffusionPipeline"),u(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(ge,"href","#diffusers.DiffusionPipeline"),u(ne,"class","relative group"),u(St,"href","/docs/diffusers/pr_2697/en/api/pipelines/text_to_video#diffusers.DiffusionPipeline"),u(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(at,"href","https://huggingface.co/"),u(at,"rel","nofollow"),u(st,"href","https://github.com/huggingface/diffusers/tree/main/examples/community"),u(st,"rel","nofollow"),u(dt,"href","https://huggingface.co/docs/diffusers/using-diffusers/custom_pipeline_overview"),u(dt,"rel","nofollow"),u(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,h){e(document.head,l),_(o,y,h),_(o,g,h),e(g,v),e(v,$),P(c,$,null),e(g,b),e(g,C),e(C,S),_(o,G,h),_(o,L,h),e(L,K),e(L,z),e(z,Q),e(L,W),_(o,Oe,h),_(o,N,h),e(N,Et),e(N,X),e(X,Mn),e(N,Ln),_(o,Ui,h),_(o,xt,h),e(xt,Nt),e(Nt,Wn),_(o,Xi,h),_(o,Dt,h),e(Dt,Hn),_(o,Ri,h),_(o,R,h),e(R,Ut),e(Ut,Se),e(Se,Vn),e(R,Fn),e(R,Xt),e(Xt,Me),e(Me,Gn),e(R,zn),e(R,Rt),e(Rt,Nn),_(o,Yi,h),_(o,Z,h),e(Z,le),e(le,Yt),P(Le,Yt,null),e(Z,Un),e(Z,Bt),e(Bt,Xn),_(o,Bi,h),_(o,de,h),e(de,Jt),e(Jt,ee),e(ee,Kt),e(Kt,Rn),e(ee,Yn),e(ee,Qt),e(Qt,Bn),e(ee,Jn),e(ee,Pt),e(Pt,Kn),e(de,Qn),e(de,Zt),e(Zt,te),e(te,eo),e(eo,We),e(We,Zn),e(te,ea),e(te,to),e(to,oo),e(oo,ta),e(te,oa),e(te,kt),e(kt,ia),_(o,Ji,h),_(o,oe,h),e(oe,fe),e(fe,io),P(He,io,null),e(oe,na),e(oe,no),e(no,aa),_(o,Ki,h),_(o,Tt,h),e(Tt,ra),_(o,Qi,h),P(Ve,o,h),_(o,Zi,h),_(o,At,h),e(At,sa),_(o,en,h),_(o,Ct,h),e(Ct,la),_(o,tn,h),P(Fe,o,h),_(o,on,h),_(o,pe,h),e(pe,da),e(pe,ao),e(ao,fa),e(pe,pa),_(o,nn,h),_(o,It,h),e(It,ca),_(o,an,h),P(Ge,o,h),_(o,rn,h),_(o,jt,h),e(jt,ma),_(o,sn,h),_(o,qt,h),e(qt,ze),e(ze,ro),e(ro,ce),e(ce,ha),e(ce,ua),e(ce,ga),e(ce,Ne),e(ze,_a),e(ze,so),e(so,me),e(me,va),e(me,ba),e(me,ya),e(me,Ue),_(o,ln,h),_(o,ie,h),e(ie,he),e(he,lo),P(Xe,lo,null),e(ie,$a),e(ie,fo),e(fo,wa),_(o,dn,h),_(o,ue,h),e(ue,po),e(po,Re),e(Re,Ea),e(ue,xa),e(ue,co),e(co,Ye),e(Ye,Da),_(o,fn,h),_(o,ne,h),e(ne,ge),e(ge,mo),P(Be,mo,null),e(ne,Pa),e(ne,ho),e(ho,ka),_(o,pn,h),_(o,w,h),P(Je,w,null),e(w,Ta),e(w,uo),e(uo,Aa),e(w,Ca),e(w,Ot),e(Ot,St),e(St,Ia),e(Ot,ja),e(w,qa),e(w,Ke),e(Ke,go),e(go,Oa),e(Ke,Sa),e(Ke,_o),e(_o,Ma),e(w,La),e(w,vo),e(vo,Wa),e(w,Ha),e(w,Qe),e(Qe,_e),e(_e,bo),e(bo,Va),e(_e,Fa),e(_e,yo),e(yo,Ga),e(_e,za),e(Qe,Na),e(Qe,ve),e(ve,$o),e($o,Ua),e(ve,Xa),e(ve,wo),e(wo,Ra),e(ve,Ya),e(w,Ba),e(w,be),P(Ze,be,null),e(be,Ja),e(be,Eo),e(Eo,Ka),e(w,Qa),e(w,ye),P(et,ye,null),e(ye,Za),e(ye,tt),e(tt,er),e(tt,xo),e(xo,tr),e(tt,or),e(w,ir),e(w,$e),P(ot,$e,null),e($e,nr),e($e,Do),e(Do,ar),e(w,rr),e(w,I),P(it,I,null),e(I,sr),e(I,Po),e(Po,lr),e(I,dr),e(I,ae),e(ae,fr),e(ae,ko),e(ko,pr),e(ae,cr),e(ae,To),e(To,mr),e(ae,hr),e(I,ur),P(we,I,null),e(I,gr),e(I,Ao),e(Ao,_r),e(I,vr),e(I,re),e(re,nt),e(nt,U),e(U,br),e(U,Co),e(Co,yr),e(U,$r),e(U,at),e(at,wr),e(U,Er),e(U,Io),e(Io,xr),e(U,Dr),e(nt,Pr),P(Ee,nt,null),e(re,kr),e(re,rt),e(rt,H),e(H,Tr),e(H,jo),e(jo,Ar),e(H,Cr),e(H,st),e(st,Ir),e(H,jr),e(H,qo),e(qo,qr),e(H,Or),e(H,Oo),e(Oo,Sr),e(H,Mr),e(H,So),e(So,Lr),e(H,Wr),e(rt,Hr),P(xe,rt,null),e(re,Vr),e(re,lt),e(lt,se),e(se,Fr),e(se,Mo),e(Mo,Gr),e(se,zr),e(se,Lo),e(Lo,Nr),e(se,Ur),e(lt,Xr),P(De,lt,null),e(I,Rr),e(I,Mt),e(Mt,Yr),e(Mt,dt),e(dt,Br),e(I,Jr),e(I,p),e(p,Kr),e(p,Wo),e(Wo,Qr),e(p,Zr),e(p,Ho),e(Ho,es),e(p,ts),e(p,Vo),e(Vo,os),e(p,is),e(p,Fo),e(Fo,ns),e(p,as),e(p,Go),e(Go,rs),e(p,ss),e(p,zo),e(zo,ls),e(p,ds),e(p,No),e(No,fs),e(p,ps),e(p,Uo),e(Uo,cs),e(p,ms),e(p,Xo),e(Xo,hs),e(p,us),e(p,Ro),e(Ro,gs),e(p,_s),e(p,Yo),e(Yo,vs),e(p,bs),e(p,Bo),e(Bo,ys),e(p,$s),e(p,Jo),e(Jo,ws),e(p,Es),e(p,Ko),e(Ko,xs),e(p,Ds),e(p,Qo),e(Qo,Ps),e(p,ks),e(p,Zo),e(Zo,Ts),e(p,As),e(p,ei),e(ei,Cs),e(p,Is),e(p,ti),e(ti,js),e(p,qs),e(p,oi),e(oi,Os),e(p,Ss),e(p,ii),e(ii,Ms),e(p,Ls),e(p,ni),e(ni,Ws),e(p,Hs),e(p,ai),e(ai,Vs),e(p,Fs),e(p,ri),e(ri,Gs),e(p,zs),e(p,si),e(si,Ns),e(p,Us),e(p,li),e(li,Xs),e(p,Rs),e(p,di),e(di,Ys),e(p,Bs),e(p,fi),e(fi,Js),e(p,Ks),e(p,pi),e(pi,Qs),e(p,Zs),e(p,ci),e(ci,el),e(p,tl),e(p,mi),e(mi,ol),e(p,il),e(p,hi),e(hi,nl),e(p,al),e(p,ui),e(ui,rl),e(p,sl),e(p,gi),e(gi,ll),e(p,dl),e(p,_i),e(_i,fl),e(p,pl),e(p,vi),e(vi,cl),e(p,ml),e(p,bi),e(bi,hl),e(p,ul),e(p,yi),e(yi,gl),e(p,_l),e(p,$i),e($i,vl),e(p,bl),e(I,yl),P(Pe,I,null),e(w,$l),e(w,Y),P(ft,Y,null),e(Y,wl),e(Y,wi),e(wi,El),e(Y,xl),e(Y,Ei),e(Ei,Dl),e(w,Pl),e(w,V),P(pt,V,null),e(V,kl),e(V,xi),e(xi,Tl),e(V,Al),e(V,Di),e(Di,Cl),e(V,Il),e(V,Pi),e(Pi,jl),e(V,ql),P(ke,V,null),e(w,Ol),e(w,q),P(ct,q,null),e(q,Sl),e(q,ki),e(ki,Ml),e(q,Ll),e(q,mt),e(mt,Wl),e(mt,Ti),e(Ti,Hl),e(mt,Vl),e(q,Fl),e(q,ht),e(ht,Gl),e(ht,Ai),e(Ai,zl),e(ht,Nl),e(q,Ul),e(q,ut),e(ut,Xl),e(ut,Ci),e(Ci,Rl),e(ut,Yl),e(q,Bl),P(Te,q,null),e(q,Jl),P(Ae,q,null),e(q,Kl),P(Ce,q,null),e(w,Ql),e(w,Ie),P(gt,Ie,null),e(Ie,Zl),e(Ie,Ii),e(Ii,ed),e(w,td),e(w,je),P(_t,je,null),e(je,od),e(je,vt),e(vt,id),e(vt,ji),e(ji,nd),e(vt,ad),cn=!0},p(o,[h]){const bt={};h&2&&(bt.$$scope={dirty:h,ctx:o}),we.$set(bt);const qi={};h&2&&(qi.$$scope={dirty:h,ctx:o}),Ee.$set(qi);const Oi={};h&2&&(Oi.$$scope={dirty:h,ctx:o}),xe.$set(Oi);const Si={};h&2&&(Si.$$scope={dirty:h,ctx:o}),De.$set(Si);const yt={};h&2&&(yt.$$scope={dirty:h,ctx:o}),Pe.$set(yt);const Mi={};h&2&&(Mi.$$scope={dirty:h,ctx:o}),ke.$set(Mi);const $t={};h&2&&($t.$$scope={dirty:h,ctx:o}),Te.$set($t);const Li={};h&2&&(Li.$$scope={dirty:h,ctx:o}),Ae.$set(Li);const Wi={};h&2&&(Wi.$$scope={dirty:h,ctx:o}),Ce.$set(Wi)},i(o){cn||(k(c.$$.fragment,o),k(Le.$$.fragment,o),k(He.$$.fragment,o),k(Ve.$$.fragment,o),k(Fe.$$.fragment,o),k(Ge.$$.fragment,o),k(Xe.$$.fragment,o),k(Be.$$.fragment,o),k(Je.$$.fragment,o),k(Ze.$$.fragment,o),k(et.$$.fragment,o),k(ot.$$.fragment,o),k(it.$$.fragment,o),k(we.$$.fragment,o),k(Ee.$$.fragment,o),k(xe.$$.fragment,o),k(De.$$.fragment,o),k(Pe.$$.fragment,o),k(ft.$$.fragment,o),k(pt.$$.fragment,o),k(ke.$$.fragment,o),k(ct.$$.fragment,o),k(Te.$$.fragment,o),k(Ae.$$.fragment,o),k(Ce.$$.fragment,o),k(gt.$$.fragment,o),k(_t.$$.fragment,o),cn=!0)},o(o){T(c.$$.fragment,o),T(Le.$$.fragment,o),T(He.$$.fragment,o),T(Ve.$$.fragment,o),T(Fe.$$.fragment,o),T(Ge.$$.fragment,o),T(Xe.$$.fragment,o),T(Be.$$.fragment,o),T(Je.$$.fragment,o),T(Ze.$$.fragment,o),T(et.$$.fragment,o),T(ot.$$.fragment,o),T(it.$$.fragment,o),T(we.$$.fragment,o),T(Ee.$$.fragment,o),T(xe.$$.fragment,o),T(De.$$.fragment,o),T(Pe.$$.fragment,o),T(ft.$$.fragment,o),T(pt.$$.fragment,o),T(ke.$$.fragment,o),T(ct.$$.fragment,o),T(Te.$$.fragment,o),T(Ae.$$.fragment,o),T(Ce.$$.fragment,o),T(gt.$$.fragment,o),T(_t.$$.fragment,o),cn=!1},d(o){t(l),o&&t(y),o&&t(g),A(c),o&&t(G),o&&t(L),o&&t(Oe),o&&t(N),o&&t(Ui),o&&t(xt),o&&t(Xi),o&&t(Dt),o&&t(Ri),o&&t(R),o&&t(Yi),o&&t(Z),A(Le),o&&t(Bi),o&&t(de),o&&t(Ji),o&&t(oe),A(He),o&&t(Ki),o&&t(Tt),o&&t(Qi),A(Ve,o),o&&t(Zi),o&&t(At),o&&t(en),o&&t(Ct),o&&t(tn),A(Fe,o),o&&t(on),o&&t(pe),o&&t(nn),o&&t(It),o&&t(an),A(Ge,o),o&&t(rn),o&&t(jt),o&&t(sn),o&&t(qt),o&&t(ln),o&&t(ie),A(Xe),o&&t(dn),o&&t(ue),o&&t(fn),o&&t(ne),A(Be),o&&t(pn),o&&t(w),A(Je),A(Ze),A(et),A(ot),A(it),A(we),A(Ee),A(xe),A(De),A(Pe),A(ft),A(pt),A(ke),A(ct),A(Te),A(Ae),A(Ce),A(gt),A(_t)}}}const Vp={local:"texttovideo-synthesis",sections:[{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example "},{local:"available-checkpoints",title:"Available checkpoints "},{local:"diffusers.DiffusionPipeline",title:"DiffusionPipeline"}],title:"Text-to-video synthesis"};function Fp(j){return Ap(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Yp extends Dp{constructor(l){super();Pp(this,l,Fp,Hp,kp,{})}}export{Yp as default,Vp as metadata};
