import{S as lh,i as ph,s as fh,e as a,k as f,w as c,t as i,M as mh,c as o,d as s,m,a as n,x as d,h as r,b as h,G as t,g as p,y as _,q as v,o as b,B as g,v as hh}from"../../chunks/vendor-hf-doc-builder.js";import{T as Hn}from"../../chunks/Tip-hf-doc-builder.js";import{I as x}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as P}from"../../chunks/CodeBlock-hf-doc-builder.js";function uh(N){let y;return{c(){y=i("It is strongly discouraged to make use of [`torch.autocast`](https://pytorch.org/docs/stable/amp.html#torch.autocast) in any of the pipelines as it can lead to black images and is always slower than using pure \n  float16 precision.")},l(u){y=r(u,"It is strongly discouraged to make use of [`torch.autocast`](https://pytorch.org/docs/stable/amp.html#torch.autocast) in any of the pipelines as it can lead to black images and is always slower than using pure \n  float16 precision.")},m(u,w){p(u,y,w)},d(u){u&&s(y)}}}function ch(N){let y;return{c(){y=i(`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},l(u){y=r(u,`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},m(u,w){p(u,y,w)},d(u){u&&s(y)}}}function dh(N){let y,u,w,A;return{c(){y=i("Consider using "),u=a("a"),w=i("model offloading"),A=i(" as another point in the optimization space: it will be much faster, but memory savings won't be as large."),this.h()},l($){y=r($,"Consider using "),u=o($,"A",{href:!0});var k=n(u);w=r(k,"model offloading"),k.forEach(s),A=r($," as another point in the optimization space: it will be much faster, but memory savings won't be as large."),this.h()},h(){h(u,"href","#model_offloading")},m($,k){p($,y,k),p($,u,k),t(u,w),p($,A,k)},d($){$&&s(y),$&&s(u),$&&s(A)}}}function _h(N){let y;return{c(){y=i("This feature requires `accelerate` version 0.17.0 or larger.")},l(u){y=r(u,"This feature requires `accelerate` version 0.17.0 or larger.")},m(u,w){p(u,y,w)},d(u){u&&s(y)}}}function vh(N){let y,u,w,A,$,k,On,ys,Bn,Za,S,Ln,ws,Xn,Yn,Ge,Wn,Kn,wt,Qn,Jn,eo,$t,Zn,to,ue,$s,M,so,ei,Es,ti,si,js,ai,oi,j,G,ks,ni,ii,Ts,ri,li,Ps,pi,fi,z,As,mi,hi,Ds,ui,ci,Ss,di,_i,H,qs,vi,bi,xs,gi,yi,Ns,wi,$i,O,Us,Ei,ji,Is,ki,Ti,Cs,Pi,Ai,B,Vs,Di,Si,Fs,qi,xi,Rs,Ni,Ui,L,Ms,Ii,Ci,Gs,Vi,Fi,zs,Ri,ao,Et,Mi,oo,X,ce,Hs,ze,Gi,Os,zi,no,He,Oe,Hi,Oi,io,de,Bi,Bs,Li,Xi,ro,Be,lo,Y,_e,Ls,Le,Yi,Xs,Wi,po,ve,Ki,Xe,Qi,Ji,fo,Ye,mo,W,be,Ys,We,Zi,Ws,er,ho,U,tr,Ks,sr,ar,Qs,or,nr,uo,Ke,co,ge,_o,K,ye,Js,Qe,ir,Zs,rr,vo,jt,lr,bo,we,go,$e,pr,kt,fr,mr,yo,Je,wo,Tt,hr,$o,Q,Ee,ea,Ze,ur,ta,cr,Eo,Pt,dr,jo,I,_r,At,vr,br,Dt,gr,yr,ko,je,wr,St,$r,Er,To,et,Po,qt,jr,Ao,J,ke,sa,tt,kr,aa,Tr,Do,xt,Pr,So,C,Ar,Nt,Dr,Sr,Ut,qr,xr,qo,Te,Nr,It,Ur,Ir,xo,st,No,Ct,Cr,Uo,Vt,Io,Z,Pe,oa,at,Vr,na,Fr,Co,Ft,Rr,Vo,Ae,Mr,Rt,Gr,zr,Fo,ot,Ro,Mt,Hr,Mo,De,Or,ia,Br,Lr,Go,Se,zo,Gt,Xr,Ho,nt,Oo,D,ra,Yr,Wr,la,Kr,Qr,pa,Jr,Zr,it,el,tl,Bo,zt,Lo,ee,qe,fa,rt,sl,ma,al,Xo,lt,Ht,ol,nl,Yo,V,il,ha,rl,ll,ua,pl,fl,Wo,Ot,ml,Ko,xe,hl,ca,ul,cl,Qo,pt,Jo,Bt,dl,Zo,ft,en,Ne,tn,te,Ue,da,mt,_l,_a,vl,sn,Lt,bl,an,Xt,gl,on,ht,nn,se,Ie,va,ut,yl,ba,wl,rn,Ce,$l,ga,El,jl,ln,Yt,kl,pn,ct,fn,Ve,Tl,ya,Pl,Al,mn,dt,hn,ae,Fe,wa,_t,Dl,$a,Sl,un,F,ql,vt,xl,Nl,bt,Ul,Il,cn,Wt,Cl,dn,Re,Ea,oe,ja,Vl,Fl,ka,Rl,Ml,Ta,Gl,zl,E,ne,Pa,Hl,Ol,Aa,Bl,Ll,Da,Xl,Yl,ie,Sa,Wl,Kl,qa,Ql,Jl,xa,Zl,ep,re,Na,tp,sp,Ua,ap,op,Ia,np,ip,le,Ca,rp,lp,Va,pp,fp,Fa,mp,hp,pe,Ra,up,cp,Ma,dp,_p,Ga,vp,bp,fe,za,gp,yp,Ha,wp,$p,Oa,Ep,jp,me,Ba,kp,Tp,La,Pp,Ap,Xa,Dp,_n,Kt,Sp,vn,R,Ya,qp,xp,Wa,Np,Up,Qt,Jt,Ip,Cp,bn,gt,gn;return k=new x({}),ze=new x({}),Be=new P({props:{code:`import torch

torch.backends.cudnn.benchmark = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cudnn.benchmark = <span class="hljs-literal">True</span>`}}),Le=new x({}),Ye=new P({props:{code:`import torch

torch.backends.cuda.matmul.allow_tf32 = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cuda.matmul.allow_tf32 = <span class="hljs-literal">True</span>`}}),We=new x({}),Ke=new P({props:{code:`pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
image = pipe(prompt).images[0]`,highlighted:`pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),ge=new Hn({props:{warning:!0,$$slots:{default:[uh]},$$scope:{ctx:N}}}),Qe=new x({}),we=new Hn({props:{$$slots:{default:[ch]},$$scope:{ctx:N}}}),Je=new P({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_attention_slicing()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_attention_slicing()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Ze=new x({}),et=new P({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_vae_slicing()
images = pipe([prompt] * 32).images`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_vae_slicing()
images = pipe([prompt] * <span class="hljs-number">32</span>).images`}}),tt=new x({}),st=new P({props:{code:`import torch
from diffusers import StableDiffusionPipeline, UniPCMultistepScheduler

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to("cuda")
prompt = "a beautiful landscape photograph"
pipe.enable_vae_tiling()
pipe.enable_xformers_memory_efficient_attention()

image = pipe([prompt], width=3840, height=2224, num_inference_steps=20).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline, UniPCMultistepScheduler

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
prompt = <span class="hljs-string">&quot;a beautiful landscape photograph&quot;</span>
pipe.enable_vae_tiling()
pipe.enable_xformers_memory_efficient_attention()

image = pipe([prompt], width=<span class="hljs-number">3840</span>, height=<span class="hljs-number">2224</span>, num_inference_steps=<span class="hljs-number">20</span>).images[<span class="hljs-number">0</span>]`}}),at=new x({}),ot=new P({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Se=new Hn({props:{$$slots:{default:[dh]},$$scope:{ctx:N}}}),nt=new P({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(1)

image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(<span class="hljs-number">1</span>)

image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),rt=new x({}),pt=new P({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",  
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_model_cpu_offload()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,  
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_model_cpu_offload()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),ft=new P({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_model_cpu_offload()
pipe.enable_attention_slicing(1)

image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_model_cpu_offload()
pipe.enable_attention_slicing(<span class="hljs-number">1</span>)

image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Ne=new Hn({props:{$$slots:{default:[_h]},$$scope:{ctx:N}}}),mt=new x({}),ht=new P({props:{code:`print(pipe.unet.conv_out.state_dict()["weight"].stride())  # (2880, 9, 3, 1)
pipe.unet.to(memory_format=torch.channels_last)  # in-place operation
print(
    pipe.unet.conv_out.state_dict()["weight"].stride()
)  # (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works`,highlighted:`<span class="hljs-built_in">print</span>(pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride())  <span class="hljs-comment"># (2880, 9, 3, 1)</span>
pipe.unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># in-place operation</span>
<span class="hljs-built_in">print</span>(
    pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride()
)  <span class="hljs-comment"># (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works</span>`}}),ut=new x({}),ct=new P({props:{code:`import time
import torch
from diffusers import StableDiffusionPipeline
import functools

# torch disable grad
torch.set_grad_enabled(False)

# set variables
n_experiments = 2
unet_runs_per_experiment = 50


# load inputs
def generate_inputs():
    sample = torch.randn(2, 4, 64, 64).half().cuda()
    timestep = torch.rand(1).half().cuda() * 999
    encoder_hidden_states = torch.randn(2, 77, 768).half().cuda()
    return sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")
unet = pipe.unet
unet.eval()
unet.to(memory_format=torch.channels_last)  # use channels_last memory format
unet.forward = functools.partial(unet.forward, return_dict=False)  # set return_dict=False as default

# warmup
for _ in range(3):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

# trace
print("tracing..")
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.eval()
print("done tracing")


# warmup and optimize graph
for _ in range(5):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


# benchmarking
with torch.inference_mode():
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        print(f"unet traced inference took {time.time() - start_time:.2f} seconds")
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        print(f"unet inference took {time.time() - start_time:.2f} seconds")

# save the model
unet_traced.save("unet_traced.pt")`,highlighted:`<span class="hljs-keyword">import</span> time
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> functools

<span class="hljs-comment"># torch disable grad</span>
torch.set_grad_enabled(<span class="hljs-literal">False</span>)

<span class="hljs-comment"># set variables</span>
n_experiments = <span class="hljs-number">2</span>
unet_runs_per_experiment = <span class="hljs-number">50</span>


<span class="hljs-comment"># load inputs</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_inputs</span>():
    sample = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">4</span>, <span class="hljs-number">64</span>, <span class="hljs-number">64</span>).half().cuda()
    timestep = torch.rand(<span class="hljs-number">1</span>).half().cuda() * <span class="hljs-number">999</span>
    encoder_hidden_states = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">77</span>, <span class="hljs-number">768</span>).half().cuda()
    <span class="hljs-keyword">return</span> sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)
unet = pipe.unet
unet.<span class="hljs-built_in">eval</span>()
unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># use channels_last memory format</span>
unet.forward = functools.partial(unet.forward, return_dict=<span class="hljs-literal">False</span>)  <span class="hljs-comment"># set return_dict=False as default</span>

<span class="hljs-comment"># warmup</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">3</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

<span class="hljs-comment"># trace</span>
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;tracing..&quot;</span>)
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.<span class="hljs-built_in">eval</span>()
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;done tracing&quot;</span>)


<span class="hljs-comment"># warmup and optimize graph</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">5</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


<span class="hljs-comment"># benchmarking</span>
<span class="hljs-keyword">with</span> torch.inference_mode():
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet traced inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)

<span class="hljs-comment"># save the model</span>
unet_traced.save(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)`}}),dt=new P({props:{code:`from diffusers import StableDiffusionPipeline
import torch
from dataclasses import dataclass


@dataclass
class UNet2DConditionOutput:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

# use jitted unet
unet_traced = torch.jit.load("unet_traced.pt")


# del pipe.unet
class TracedUNet(torch.nn.Module):
    def __init__(self):
        super().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    def forward(self, latent_model_input, t, encoder_hidden_states):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[0]
        return UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

with torch.inference_mode():
    image = pipe([prompt] * 1, num_inference_steps=50).images[0]`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> dataclasses <span class="hljs-keyword">import</span> dataclass


<span class="hljs-meta">@dataclass</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">UNet2DConditionOutput</span>:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># use jitted unet</span>
unet_traced = torch.jit.load(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)


<span class="hljs-comment"># del pipe.unet</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">TracedUNet</span>(torch.nn.Module):
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self</span>):
        <span class="hljs-built_in">super</span>().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    <span class="hljs-keyword">def</span> <span class="hljs-title function_">forward</span>(<span class="hljs-params">self, latent_model_input, t, encoder_hidden_states</span>):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[<span class="hljs-number">0</span>]
        <span class="hljs-keyword">return</span> UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

<span class="hljs-keyword">with</span> torch.inference_mode():
    image = pipe([prompt] * <span class="hljs-number">1</span>, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]`}}),_t=new x({}),gt=new P({props:{code:`from diffusers import StableDiffusionPipeline
import torch

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

pipe.enable_xformers_memory_efficient_attention()

with torch.inference_mode():
    sample = pipe("a small cat")

# optional: You can disable it via
# pipe.disable_xformers_memory_efficient_attention()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-keyword">with</span> torch.inference_mode():
    sample = pipe(<span class="hljs-string">&quot;a small cat&quot;</span>)

<span class="hljs-comment"># optional: You can disable it via</span>
<span class="hljs-comment"># pipe.disable_xformers_memory_efficient_attention()</span>`}}),{c(){y=a("meta"),u=f(),w=a("h1"),A=a("a"),$=a("span"),c(k.$$.fragment),On=f(),ys=a("span"),Bn=i("Memory and speed"),Za=f(),S=a("p"),Ln=i("We present some techniques and ideas to optimize \u{1F917} Diffusers "),ws=a("em"),Xn=i("inference"),Yn=i(" for memory or speed. As a general rule, we recommend the use of "),Ge=a("a"),Wn=i("xFormers"),Kn=i(" for memory efficient attention, please see the recommended "),wt=a("a"),Qn=i("installation instructions"),Jn=i("."),eo=f(),$t=a("p"),Zn=i("We\u2019ll discuss how the following settings impact performance and memory."),to=f(),ue=a("table"),$s=a("thead"),M=a("tr"),so=a("th"),ei=f(),Es=a("th"),ti=i("Latency"),si=f(),js=a("th"),ai=i("Speedup"),oi=f(),j=a("tbody"),G=a("tr"),ks=a("td"),ni=i("original"),ii=f(),Ts=a("td"),ri=i("9.50s"),li=f(),Ps=a("td"),pi=i("x1"),fi=f(),z=a("tr"),As=a("td"),mi=i("cuDNN auto-tuner"),hi=f(),Ds=a("td"),ui=i("9.37s"),ci=f(),Ss=a("td"),di=i("x1.01"),_i=f(),H=a("tr"),qs=a("td"),vi=i("fp16"),bi=f(),xs=a("td"),gi=i("3.61s"),yi=f(),Ns=a("td"),wi=i("x2.63"),$i=f(),O=a("tr"),Us=a("td"),Ei=i("channels last"),ji=f(),Is=a("td"),ki=i("3.30s"),Ti=f(),Cs=a("td"),Pi=i("x2.88"),Ai=f(),B=a("tr"),Vs=a("td"),Di=i("traced UNet"),Si=f(),Fs=a("td"),qi=i("3.21s"),xi=f(),Rs=a("td"),Ni=i("x2.96"),Ui=f(),L=a("tr"),Ms=a("td"),Ii=i("memory efficient attention"),Ci=f(),Gs=a("td"),Vi=i("2.63s"),Fi=f(),zs=a("td"),Ri=i("x3.61"),ao=f(),Et=a("em"),Mi=i(`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),oo=f(),X=a("h2"),ce=a("a"),Hs=a("span"),c(ze.$$.fragment),Gi=f(),Os=a("span"),zi=i("Enable cuDNN auto-tuner"),no=f(),He=a("p"),Oe=a("a"),Hi=i("NVIDIA cuDNN"),Oi=i("\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),io=f(),de=a("p"),Bi=i("Since we\u2019re using "),Bs=a("strong"),Li=i("convolutional networks"),Xi=i(" (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),ro=f(),c(Be.$$.fragment),lo=f(),Y=a("h3"),_e=a("a"),Ls=a("span"),c(Le.$$.fragment),Yi=f(),Xs=a("span"),Wi=i("Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),po=f(),ve=a("p"),Ki=i("On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Xe=a("a"),Qi=i("here"),Ji=i(". All you need to do is to add this before your inference:"),fo=f(),c(Ye.$$.fragment),mo=f(),W=a("h2"),be=a("a"),Ys=a("span"),c(We.$$.fragment),Zi=f(),Ws=a("span"),er=i("Half precision weights"),ho=f(),U=a("p"),tr=i("To save more GPU memory and get more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Ks=a("code"),sr=i("fp16"),ar=i(", and telling PyTorch to use the "),Qs=a("code"),or=i("float16"),nr=i(" type when loading them:"),uo=f(),c(Ke.$$.fragment),co=f(),c(ge.$$.fragment),_o=f(),K=a("h2"),ye=a("a"),Js=a("span"),c(Qe.$$.fragment),ir=f(),Zs=a("span"),rr=i("Sliced attention for additional memory savings"),vo=f(),jt=a("p"),lr=i("For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),bo=f(),c(we.$$.fragment),go=f(),$e=a("p"),pr=i("To perform the attention computation sequentially over each head, you only need to invoke "),kt=a("a"),fr=i("enable_attention_slicing()"),mr=i(" in your pipeline before inference, like here:"),yo=f(),c(Je.$$.fragment),wo=f(),Tt=a("p"),hr=i("There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),$o=f(),Q=a("h2"),Ee=a("a"),ea=a("span"),c(Ze.$$.fragment),ur=f(),ta=a("span"),cr=i("Sliced VAE decode for larger batches"),Eo=f(),Pt=a("p"),dr=i("To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),jo=f(),I=a("p"),_r=i("You likely want to couple this with "),At=a("a"),vr=i("enable_attention_slicing()"),br=i(" or "),Dt=a("a"),gr=i("enable_xformers_memory_efficient_attention()"),yr=i(" to further minimize memory use."),ko=f(),je=a("p"),wr=i("To perform the VAE decode one image at a time, invoke "),St=a("a"),$r=i("enable_vae_slicing()"),Er=i(" in your pipeline before inference. For example:"),To=f(),c(et.$$.fragment),Po=f(),qt=a("p"),jr=i("You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),Ao=f(),J=a("h2"),ke=a("a"),sa=a("span"),c(tt.$$.fragment),kr=f(),aa=a("span"),Tr=i("Tiled VAE decode and encode for large images"),Do=f(),xt=a("p"),Pr=i("Tiled VAE processing makes it possible to work with large images on limited VRAM. For example, generating 4k images in 8GB of VRAM. Tiled VAE decoder splits the image into overlapping tiles, decodes the tiles, and blends the outputs to make the final image."),So=f(),C=a("p"),Ar=i("You want to couple this with "),Nt=a("a"),Dr=i("enable_attention_slicing()"),Sr=i(" or "),Ut=a("a"),qr=i("enable_xformers_memory_efficient_attention()"),xr=i(" to further minimize memory use."),qo=f(),Te=a("p"),Nr=i("To use tiled VAE processing, invoke "),It=a("a"),Ur=i("enable_vae_tiling()"),Ir=i(" in your pipeline before inference. For example:"),xo=f(),c(st.$$.fragment),No=f(),Ct=a("p"),Cr=i("The output image will have some tile-to-tile tone variation from the tiles having separate decoders, but you shouldn\u2019t see sharp seams between the tiles. The tiling is turned off for images that are 512x512 or smaller."),Uo=f(),Vt=a("a"),Io=f(),Z=a("h2"),Pe=a("a"),oa=a("span"),c(at.$$.fragment),Vr=f(),na=a("span"),Fr=i("Offloading to CPU with accelerate for memory savings"),Co=f(),Ft=a("p"),Rr=i("For additional memory savings, you can offload the weights to CPU and only load them to GPU when performing the forward pass."),Vo=f(),Ae=a("p"),Mr=i("To perform CPU offloading, all you have to do is invoke "),Rt=a("a"),Gr=i("enable_sequential_cpu_offload()"),zr=i(":"),Fo=f(),c(ot.$$.fragment),Ro=f(),Mt=a("p"),Hr=i("And you can get the memory consumption to < 3GB."),Mo=f(),De=a("p"),Or=i("Note that this method works at the submodule level, not on whole models. This is the best way to minimize memory consumption, but inference is much slower due to the iterative nature of the process. The UNet component of the pipeline runs several times (as many as "),ia=a("code"),Br=i("num_inference_steps"),Lr=i("); each time, the different submodules of the UNet are sequentially onloaded and then offloaded as they are needed, so the number of memory transfers is large."),Go=f(),c(Se.$$.fragment),zo=f(),Gt=a("p"),Xr=i("It is also possible to chain offloading with attention slicing for minimal memory consumption (< 2GB)."),Ho=f(),c(nt.$$.fragment),Oo=f(),D=a("p"),ra=a("strong"),Yr=i("Note"),Wr=i(": When using "),la=a("code"),Kr=i("enable_sequential_cpu_offload()"),Qr=i(", it is important to "),pa=a("strong"),Jr=i("not"),Zr=i(" move the pipeline to CUDA beforehand or else the gain in memory consumption will only be minimal. See "),it=a("a"),el=i("this issue"),tl=i(" for more information."),Bo=f(),zt=a("a"),Lo=f(),ee=a("h2"),qe=a("a"),fa=a("span"),c(rt.$$.fragment),sl=f(),ma=a("span"),al=i("Model offloading for fast inference and memory savings"),Xo=f(),lt=a("p"),Ht=a("a"),ol=i("Sequential CPU offloading"),nl=i(", as discussed in the previous section, preserves a lot of memory but makes inference slower, because submodules are moved to GPU as needed, and immediately returned to CPU when a new module runs."),Yo=f(),V=a("p"),il=i("Full-model offloading is an alternative that moves whole models to the GPU, instead of handling each model\u2019s constituent "),ha=a("em"),rl=i("modules"),ll=i(". This results in a negligible impact on inference time (compared with moving the pipeline to "),ua=a("code"),pl=i("cuda"),fl=i("), while still providing some memory savings."),Wo=f(),Ot=a("p"),ml=i(`In this scenario, only one of the main components of the pipeline (typically: text encoder, unet and vae)
will be in the GPU while the others wait in the CPU. Components like the UNet that run for multiple iterations will stay on GPU until they are no longer needed.`),Ko=f(),xe=a("p"),hl=i("This feature can be enabled by invoking "),ca=a("code"),ul=i("enable_model_cpu_offload()"),cl=i(" on the pipeline, as shown below."),Qo=f(),c(pt.$$.fragment),Jo=f(),Bt=a("p"),dl=i("This is also compatible with attention slicing for additional memory savings."),Zo=f(),c(ft.$$.fragment),en=f(),c(Ne.$$.fragment),tn=f(),te=a("h2"),Ue=a("a"),da=a("span"),c(mt.$$.fragment),_l=f(),_a=a("span"),vl=i("Using Channels Last memory format"),sn=f(),Lt=a("p"),bl=i("Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),an=f(),Xt=a("p"),gl=i("For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),on=f(),c(ht.$$.fragment),nn=f(),se=a("h2"),Ie=a("a"),va=a("span"),c(ut.$$.fragment),yl=f(),ba=a("span"),wl=i("Tracing"),rn=f(),Ce=a("p"),$l=i("Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),ga=a("code"),El=i("ScriptFunction"),jl=i(" is returned that will be optimized using just-in-time compilation."),ln=f(),Yt=a("p"),kl=i("To trace our UNet model, we can use the following:"),pn=f(),c(ct.$$.fragment),fn=f(),Ve=a("p"),Tl=i("Then we can replace the "),ya=a("code"),Pl=i("unet"),Al=i(" attribute of the pipeline with the traced model like the following"),mn=f(),c(dt.$$.fragment),hn=f(),ae=a("h2"),Fe=a("a"),wa=a("span"),c(_t.$$.fragment),Dl=f(),$a=a("span"),Sl=i("Memory Efficient Attention"),un=f(),F=a("p"),ql=i("Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),vt=a("a"),xl=i("code"),Nl=i(", "),bt=a("a"),Ul=i("paper"),Il=i("."),cn=f(),Wt=a("p"),Cl=i("Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),dn=f(),Re=a("table"),Ea=a("thead"),oe=a("tr"),ja=a("th"),Vl=i("GPU"),Fl=f(),ka=a("th"),Rl=i("Base Attention FP16"),Ml=f(),Ta=a("th"),Gl=i("Memory Efficient Attention FP16"),zl=f(),E=a("tbody"),ne=a("tr"),Pa=a("td"),Hl=i("NVIDIA Tesla T4"),Ol=f(),Aa=a("td"),Bl=i("3.5it/s"),Ll=f(),Da=a("td"),Xl=i("5.5it/s"),Yl=f(),ie=a("tr"),Sa=a("td"),Wl=i("NVIDIA 3060 RTX"),Kl=f(),qa=a("td"),Ql=i("4.6it/s"),Jl=f(),xa=a("td"),Zl=i("7.8it/s"),ep=f(),re=a("tr"),Na=a("td"),tp=i("NVIDIA A10G"),sp=f(),Ua=a("td"),ap=i("8.88it/s"),op=f(),Ia=a("td"),np=i("15.6it/s"),ip=f(),le=a("tr"),Ca=a("td"),rp=i("NVIDIA RTX A6000"),lp=f(),Va=a("td"),pp=i("11.7it/s"),fp=f(),Fa=a("td"),mp=i("21.09it/s"),hp=f(),pe=a("tr"),Ra=a("td"),up=i("NVIDIA TITAN RTX"),cp=f(),Ma=a("td"),dp=i("12.51it/s"),_p=f(),Ga=a("td"),vp=i("18.22it/s"),bp=f(),fe=a("tr"),za=a("td"),gp=i("A100-SXM4-40GB"),yp=f(),Ha=a("td"),wp=i("18.6it/s"),$p=f(),Oa=a("td"),Ep=i("29.it/s"),jp=f(),me=a("tr"),Ba=a("td"),kp=i("A100-SXM-80GB"),Tp=f(),La=a("td"),Pp=i("18.7it/s"),Ap=f(),Xa=a("td"),Dp=i("29.5it/s"),_n=f(),Kt=a("p"),Sp=i("To leverage it just make sure you have:"),vn=f(),R=a("ul"),Ya=a("li"),qp=i("PyTorch > 1.12"),xp=f(),Wa=a("li"),Np=i("Cuda available"),Up=f(),Qt=a("li"),Jt=a("a"),Ip=i("Installed the xformers library"),Cp=i("."),bn=f(),c(gt.$$.fragment),this.h()},l(e){const l=mh('[data-svelte="svelte-1phssyn"]',document.head);y=o(l,"META",{name:!0,content:!0}),l.forEach(s),u=m(e),w=o(e,"H1",{class:!0});var yt=n(w);A=o(yt,"A",{id:!0,class:!0,href:!0});var Ka=n(A);$=o(Ka,"SPAN",{});var Qa=n($);d(k.$$.fragment,Qa),Qa.forEach(s),Ka.forEach(s),On=m(yt),ys=o(yt,"SPAN",{});var Ja=n(ys);Bn=r(Ja,"Memory and speed"),Ja.forEach(s),yt.forEach(s),Za=m(e),S=o(e,"P",{});var Me=n(S);Ln=r(Me,"We present some techniques and ideas to optimize \u{1F917} Diffusers "),ws=o(Me,"EM",{});var Mp=n(ws);Xn=r(Mp,"inference"),Mp.forEach(s),Yn=r(Me," for memory or speed. As a general rule, we recommend the use of "),Ge=o(Me,"A",{href:!0,rel:!0});var Gp=n(Ge);Wn=r(Gp,"xFormers"),Gp.forEach(s),Kn=r(Me," for memory efficient attention, please see the recommended "),wt=o(Me,"A",{href:!0});var zp=n(wt);Qn=r(zp,"installation instructions"),zp.forEach(s),Jn=r(Me,"."),Me.forEach(s),eo=m(e),$t=o(e,"P",{});var Hp=n($t);Zn=r(Hp,"We\u2019ll discuss how the following settings impact performance and memory."),Hp.forEach(s),to=m(e),ue=o(e,"TABLE",{});var yn=n(ue);$s=o(yn,"THEAD",{});var Op=n($s);M=o(Op,"TR",{});var Zt=n(M);so=o(Zt,"TH",{}),n(so).forEach(s),ei=m(Zt),Es=o(Zt,"TH",{});var Bp=n(Es);ti=r(Bp,"Latency"),Bp.forEach(s),si=m(Zt),js=o(Zt,"TH",{});var Lp=n(js);ai=r(Lp,"Speedup"),Lp.forEach(s),Zt.forEach(s),Op.forEach(s),oi=m(yn),j=o(yn,"TBODY",{});var q=n(j);G=o(q,"TR",{});var es=n(G);ks=o(es,"TD",{});var Xp=n(ks);ni=r(Xp,"original"),Xp.forEach(s),ii=m(es),Ts=o(es,"TD",{});var Yp=n(Ts);ri=r(Yp,"9.50s"),Yp.forEach(s),li=m(es),Ps=o(es,"TD",{});var Wp=n(Ps);pi=r(Wp,"x1"),Wp.forEach(s),es.forEach(s),fi=m(q),z=o(q,"TR",{});var ts=n(z);As=o(ts,"TD",{});var Kp=n(As);mi=r(Kp,"cuDNN auto-tuner"),Kp.forEach(s),hi=m(ts),Ds=o(ts,"TD",{});var Qp=n(Ds);ui=r(Qp,"9.37s"),Qp.forEach(s),ci=m(ts),Ss=o(ts,"TD",{});var Jp=n(Ss);di=r(Jp,"x1.01"),Jp.forEach(s),ts.forEach(s),_i=m(q),H=o(q,"TR",{});var ss=n(H);qs=o(ss,"TD",{});var Zp=n(qs);vi=r(Zp,"fp16"),Zp.forEach(s),bi=m(ss),xs=o(ss,"TD",{});var ef=n(xs);gi=r(ef,"3.61s"),ef.forEach(s),yi=m(ss),Ns=o(ss,"TD",{});var tf=n(Ns);wi=r(tf,"x2.63"),tf.forEach(s),ss.forEach(s),$i=m(q),O=o(q,"TR",{});var as=n(O);Us=o(as,"TD",{});var sf=n(Us);Ei=r(sf,"channels last"),sf.forEach(s),ji=m(as),Is=o(as,"TD",{});var af=n(Is);ki=r(af,"3.30s"),af.forEach(s),Ti=m(as),Cs=o(as,"TD",{});var of=n(Cs);Pi=r(of,"x2.88"),of.forEach(s),as.forEach(s),Ai=m(q),B=o(q,"TR",{});var os=n(B);Vs=o(os,"TD",{});var nf=n(Vs);Di=r(nf,"traced UNet"),nf.forEach(s),Si=m(os),Fs=o(os,"TD",{});var rf=n(Fs);qi=r(rf,"3.21s"),rf.forEach(s),xi=m(os),Rs=o(os,"TD",{});var lf=n(Rs);Ni=r(lf,"x2.96"),lf.forEach(s),os.forEach(s),Ui=m(q),L=o(q,"TR",{});var ns=n(L);Ms=o(ns,"TD",{});var pf=n(Ms);Ii=r(pf,"memory efficient attention"),pf.forEach(s),Ci=m(ns),Gs=o(ns,"TD",{});var ff=n(Gs);Vi=r(ff,"2.63s"),ff.forEach(s),Fi=m(ns),zs=o(ns,"TD",{});var mf=n(zs);Ri=r(mf,"x3.61"),mf.forEach(s),ns.forEach(s),q.forEach(s),yn.forEach(s),ao=m(e),Et=o(e,"EM",{});var hf=n(Et);Mi=r(hf,`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),hf.forEach(s),oo=m(e),X=o(e,"H2",{class:!0});var wn=n(X);ce=o(wn,"A",{id:!0,class:!0,href:!0});var uf=n(ce);Hs=o(uf,"SPAN",{});var cf=n(Hs);d(ze.$$.fragment,cf),cf.forEach(s),uf.forEach(s),Gi=m(wn),Os=o(wn,"SPAN",{});var df=n(Os);zi=r(df,"Enable cuDNN auto-tuner"),df.forEach(s),wn.forEach(s),no=m(e),He=o(e,"P",{});var Vp=n(He);Oe=o(Vp,"A",{href:!0,rel:!0});var _f=n(Oe);Hi=r(_f,"NVIDIA cuDNN"),_f.forEach(s),Oi=r(Vp,"\xA0supports many algorithms to compute a convolution. Autotuner runs a short benchmark and selects the kernel with the best performance on a given hardware for a given input size."),Vp.forEach(s),io=m(e),de=o(e,"P",{});var $n=n(de);Bi=r($n,"Since we\u2019re using "),Bs=o($n,"STRONG",{});var vf=n(Bs);Li=r(vf,"convolutional networks"),vf.forEach(s),Xi=r($n," (other types currently not supported), we can enable cuDNN autotuner before launching the inference by setting:"),$n.forEach(s),ro=m(e),d(Be.$$.fragment,e),lo=m(e),Y=o(e,"H3",{class:!0});var En=n(Y);_e=o(En,"A",{id:!0,class:!0,href:!0});var bf=n(_e);Ls=o(bf,"SPAN",{});var gf=n(Ls);d(Le.$$.fragment,gf),gf.forEach(s),bf.forEach(s),Yi=m(En),Xs=o(En,"SPAN",{});var yf=n(Xs);Wi=r(yf,"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),yf.forEach(s),En.forEach(s),po=m(e),ve=o(e,"P",{});var jn=n(ve);Ki=r(jn,"On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Xe=o(jn,"A",{href:!0,rel:!0});var wf=n(Xe);Qi=r(wf,"here"),wf.forEach(s),Ji=r(jn,". All you need to do is to add this before your inference:"),jn.forEach(s),fo=m(e),d(Ye.$$.fragment,e),mo=m(e),W=o(e,"H2",{class:!0});var kn=n(W);be=o(kn,"A",{id:!0,class:!0,href:!0});var $f=n(be);Ys=o($f,"SPAN",{});var Ef=n(Ys);d(We.$$.fragment,Ef),Ef.forEach(s),$f.forEach(s),Zi=m(kn),Ws=o(kn,"SPAN",{});var jf=n(Ws);er=r(jf,"Half precision weights"),jf.forEach(s),kn.forEach(s),ho=m(e),U=o(e,"P",{});var is=n(U);tr=r(is,"To save more GPU memory and get more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Ks=o(is,"CODE",{});var kf=n(Ks);sr=r(kf,"fp16"),kf.forEach(s),ar=r(is,", and telling PyTorch to use the "),Qs=o(is,"CODE",{});var Tf=n(Qs);or=r(Tf,"float16"),Tf.forEach(s),nr=r(is," type when loading them:"),is.forEach(s),uo=m(e),d(Ke.$$.fragment,e),co=m(e),d(ge.$$.fragment,e),_o=m(e),K=o(e,"H2",{class:!0});var Tn=n(K);ye=o(Tn,"A",{id:!0,class:!0,href:!0});var Pf=n(ye);Js=o(Pf,"SPAN",{});var Af=n(Js);d(Qe.$$.fragment,Af),Af.forEach(s),Pf.forEach(s),ir=m(Tn),Zs=o(Tn,"SPAN",{});var Df=n(Zs);rr=r(Df,"Sliced attention for additional memory savings"),Df.forEach(s),Tn.forEach(s),vo=m(e),jt=o(e,"P",{});var Sf=n(jt);lr=r(Sf,"For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),Sf.forEach(s),bo=m(e),d(we.$$.fragment,e),go=m(e),$e=o(e,"P",{});var Pn=n($e);pr=r(Pn,"To perform the attention computation sequentially over each head, you only need to invoke "),kt=o(Pn,"A",{href:!0});var qf=n(kt);fr=r(qf,"enable_attention_slicing()"),qf.forEach(s),mr=r(Pn," in your pipeline before inference, like here:"),Pn.forEach(s),yo=m(e),d(Je.$$.fragment,e),wo=m(e),Tt=o(e,"P",{});var xf=n(Tt);hr=r(xf,"There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),xf.forEach(s),$o=m(e),Q=o(e,"H2",{class:!0});var An=n(Q);Ee=o(An,"A",{id:!0,class:!0,href:!0});var Nf=n(Ee);ea=o(Nf,"SPAN",{});var Uf=n(ea);d(Ze.$$.fragment,Uf),Uf.forEach(s),Nf.forEach(s),ur=m(An),ta=o(An,"SPAN",{});var If=n(ta);cr=r(If,"Sliced VAE decode for larger batches"),If.forEach(s),An.forEach(s),Eo=m(e),Pt=o(e,"P",{});var Cf=n(Pt);dr=r(Cf,"To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),Cf.forEach(s),jo=m(e),I=o(e,"P",{});var rs=n(I);_r=r(rs,"You likely want to couple this with "),At=o(rs,"A",{href:!0});var Vf=n(At);vr=r(Vf,"enable_attention_slicing()"),Vf.forEach(s),br=r(rs," or "),Dt=o(rs,"A",{href:!0});var Ff=n(Dt);gr=r(Ff,"enable_xformers_memory_efficient_attention()"),Ff.forEach(s),yr=r(rs," to further minimize memory use."),rs.forEach(s),ko=m(e),je=o(e,"P",{});var Dn=n(je);wr=r(Dn,"To perform the VAE decode one image at a time, invoke "),St=o(Dn,"A",{href:!0});var Rf=n(St);$r=r(Rf,"enable_vae_slicing()"),Rf.forEach(s),Er=r(Dn," in your pipeline before inference. For example:"),Dn.forEach(s),To=m(e),d(et.$$.fragment,e),Po=m(e),qt=o(e,"P",{});var Mf=n(qt);jr=r(Mf,"You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),Mf.forEach(s),Ao=m(e),J=o(e,"H2",{class:!0});var Sn=n(J);ke=o(Sn,"A",{id:!0,class:!0,href:!0});var Gf=n(ke);sa=o(Gf,"SPAN",{});var zf=n(sa);d(tt.$$.fragment,zf),zf.forEach(s),Gf.forEach(s),kr=m(Sn),aa=o(Sn,"SPAN",{});var Hf=n(aa);Tr=r(Hf,"Tiled VAE decode and encode for large images"),Hf.forEach(s),Sn.forEach(s),Do=m(e),xt=o(e,"P",{});var Of=n(xt);Pr=r(Of,"Tiled VAE processing makes it possible to work with large images on limited VRAM. For example, generating 4k images in 8GB of VRAM. Tiled VAE decoder splits the image into overlapping tiles, decodes the tiles, and blends the outputs to make the final image."),Of.forEach(s),So=m(e),C=o(e,"P",{});var ls=n(C);Ar=r(ls,"You want to couple this with "),Nt=o(ls,"A",{href:!0});var Bf=n(Nt);Dr=r(Bf,"enable_attention_slicing()"),Bf.forEach(s),Sr=r(ls," or "),Ut=o(ls,"A",{href:!0});var Lf=n(Ut);qr=r(Lf,"enable_xformers_memory_efficient_attention()"),Lf.forEach(s),xr=r(ls," to further minimize memory use."),ls.forEach(s),qo=m(e),Te=o(e,"P",{});var qn=n(Te);Nr=r(qn,"To use tiled VAE processing, invoke "),It=o(qn,"A",{href:!0});var Xf=n(It);Ur=r(Xf,"enable_vae_tiling()"),Xf.forEach(s),Ir=r(qn," in your pipeline before inference. For example:"),qn.forEach(s),xo=m(e),d(st.$$.fragment,e),No=m(e),Ct=o(e,"P",{});var Yf=n(Ct);Cr=r(Yf,"The output image will have some tile-to-tile tone variation from the tiles having separate decoders, but you shouldn\u2019t see sharp seams between the tiles. The tiling is turned off for images that are 512x512 or smaller."),Yf.forEach(s),Uo=m(e),Vt=o(e,"A",{name:!0}),n(Vt).forEach(s),Io=m(e),Z=o(e,"H2",{class:!0});var xn=n(Z);Pe=o(xn,"A",{id:!0,class:!0,href:!0});var Wf=n(Pe);oa=o(Wf,"SPAN",{});var Kf=n(oa);d(at.$$.fragment,Kf),Kf.forEach(s),Wf.forEach(s),Vr=m(xn),na=o(xn,"SPAN",{});var Qf=n(na);Fr=r(Qf,"Offloading to CPU with accelerate for memory savings"),Qf.forEach(s),xn.forEach(s),Co=m(e),Ft=o(e,"P",{});var Jf=n(Ft);Rr=r(Jf,"For additional memory savings, you can offload the weights to CPU and only load them to GPU when performing the forward pass."),Jf.forEach(s),Vo=m(e),Ae=o(e,"P",{});var Nn=n(Ae);Mr=r(Nn,"To perform CPU offloading, all you have to do is invoke "),Rt=o(Nn,"A",{href:!0});var Zf=n(Rt);Gr=r(Zf,"enable_sequential_cpu_offload()"),Zf.forEach(s),zr=r(Nn,":"),Nn.forEach(s),Fo=m(e),d(ot.$$.fragment,e),Ro=m(e),Mt=o(e,"P",{});var em=n(Mt);Hr=r(em,"And you can get the memory consumption to < 3GB."),em.forEach(s),Mo=m(e),De=o(e,"P",{});var Un=n(De);Or=r(Un,"Note that this method works at the submodule level, not on whole models. This is the best way to minimize memory consumption, but inference is much slower due to the iterative nature of the process. The UNet component of the pipeline runs several times (as many as "),ia=o(Un,"CODE",{});var tm=n(ia);Br=r(tm,"num_inference_steps"),tm.forEach(s),Lr=r(Un,"); each time, the different submodules of the UNet are sequentially onloaded and then offloaded as they are needed, so the number of memory transfers is large."),Un.forEach(s),Go=m(e),d(Se.$$.fragment,e),zo=m(e),Gt=o(e,"P",{});var sm=n(Gt);Xr=r(sm,"It is also possible to chain offloading with attention slicing for minimal memory consumption (< 2GB)."),sm.forEach(s),Ho=m(e),d(nt.$$.fragment,e),Oo=m(e),D=o(e,"P",{});var he=n(D);ra=o(he,"STRONG",{});var am=n(ra);Yr=r(am,"Note"),am.forEach(s),Wr=r(he,": When using "),la=o(he,"CODE",{});var om=n(la);Kr=r(om,"enable_sequential_cpu_offload()"),om.forEach(s),Qr=r(he,", it is important to "),pa=o(he,"STRONG",{});var nm=n(pa);Jr=r(nm,"not"),nm.forEach(s),Zr=r(he," move the pipeline to CUDA beforehand or else the gain in memory consumption will only be minimal. See "),it=o(he,"A",{href:!0,rel:!0});var im=n(it);el=r(im,"this issue"),im.forEach(s),tl=r(he," for more information."),he.forEach(s),Bo=m(e),zt=o(e,"A",{name:!0}),n(zt).forEach(s),Lo=m(e),ee=o(e,"H2",{class:!0});var In=n(ee);qe=o(In,"A",{id:!0,class:!0,href:!0});var rm=n(qe);fa=o(rm,"SPAN",{});var lm=n(fa);d(rt.$$.fragment,lm),lm.forEach(s),rm.forEach(s),sl=m(In),ma=o(In,"SPAN",{});var pm=n(ma);al=r(pm,"Model offloading for fast inference and memory savings"),pm.forEach(s),In.forEach(s),Xo=m(e),lt=o(e,"P",{});var Fp=n(lt);Ht=o(Fp,"A",{href:!0});var fm=n(Ht);ol=r(fm,"Sequential CPU offloading"),fm.forEach(s),nl=r(Fp,", as discussed in the previous section, preserves a lot of memory but makes inference slower, because submodules are moved to GPU as needed, and immediately returned to CPU when a new module runs."),Fp.forEach(s),Yo=m(e),V=o(e,"P",{});var ps=n(V);il=r(ps,"Full-model offloading is an alternative that moves whole models to the GPU, instead of handling each model\u2019s constituent "),ha=o(ps,"EM",{});var mm=n(ha);rl=r(mm,"modules"),mm.forEach(s),ll=r(ps,". This results in a negligible impact on inference time (compared with moving the pipeline to "),ua=o(ps,"CODE",{});var hm=n(ua);pl=r(hm,"cuda"),hm.forEach(s),fl=r(ps,"), while still providing some memory savings."),ps.forEach(s),Wo=m(e),Ot=o(e,"P",{});var um=n(Ot);ml=r(um,`In this scenario, only one of the main components of the pipeline (typically: text encoder, unet and vae)
will be in the GPU while the others wait in the CPU. Components like the UNet that run for multiple iterations will stay on GPU until they are no longer needed.`),um.forEach(s),Ko=m(e),xe=o(e,"P",{});var Cn=n(xe);hl=r(Cn,"This feature can be enabled by invoking "),ca=o(Cn,"CODE",{});var cm=n(ca);ul=r(cm,"enable_model_cpu_offload()"),cm.forEach(s),cl=r(Cn," on the pipeline, as shown below."),Cn.forEach(s),Qo=m(e),d(pt.$$.fragment,e),Jo=m(e),Bt=o(e,"P",{});var dm=n(Bt);dl=r(dm,"This is also compatible with attention slicing for additional memory savings."),dm.forEach(s),Zo=m(e),d(ft.$$.fragment,e),en=m(e),d(Ne.$$.fragment,e),tn=m(e),te=o(e,"H2",{class:!0});var Vn=n(te);Ue=o(Vn,"A",{id:!0,class:!0,href:!0});var _m=n(Ue);da=o(_m,"SPAN",{});var vm=n(da);d(mt.$$.fragment,vm),vm.forEach(s),_m.forEach(s),_l=m(Vn),_a=o(Vn,"SPAN",{});var bm=n(_a);vl=r(bm,"Using Channels Last memory format"),bm.forEach(s),Vn.forEach(s),sn=m(e),Lt=o(e,"P",{});var gm=n(Lt);bl=r(gm,"Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),gm.forEach(s),an=m(e),Xt=o(e,"P",{});var ym=n(Xt);gl=r(ym,"For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),ym.forEach(s),on=m(e),d(ht.$$.fragment,e),nn=m(e),se=o(e,"H2",{class:!0});var Fn=n(se);Ie=o(Fn,"A",{id:!0,class:!0,href:!0});var wm=n(Ie);va=o(wm,"SPAN",{});var $m=n(va);d(ut.$$.fragment,$m),$m.forEach(s),wm.forEach(s),yl=m(Fn),ba=o(Fn,"SPAN",{});var Em=n(ba);wl=r(Em,"Tracing"),Em.forEach(s),Fn.forEach(s),rn=m(e),Ce=o(e,"P",{});var Rn=n(Ce);$l=r(Rn,"Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),ga=o(Rn,"CODE",{});var jm=n(ga);El=r(jm,"ScriptFunction"),jm.forEach(s),jl=r(Rn," is returned that will be optimized using just-in-time compilation."),Rn.forEach(s),ln=m(e),Yt=o(e,"P",{});var km=n(Yt);kl=r(km,"To trace our UNet model, we can use the following:"),km.forEach(s),pn=m(e),d(ct.$$.fragment,e),fn=m(e),Ve=o(e,"P",{});var Mn=n(Ve);Tl=r(Mn,"Then we can replace the "),ya=o(Mn,"CODE",{});var Tm=n(ya);Pl=r(Tm,"unet"),Tm.forEach(s),Al=r(Mn," attribute of the pipeline with the traced model like the following"),Mn.forEach(s),mn=m(e),d(dt.$$.fragment,e),hn=m(e),ae=o(e,"H2",{class:!0});var Gn=n(ae);Fe=o(Gn,"A",{id:!0,class:!0,href:!0});var Pm=n(Fe);wa=o(Pm,"SPAN",{});var Am=n(wa);d(_t.$$.fragment,Am),Am.forEach(s),Pm.forEach(s),Dl=m(Gn),$a=o(Gn,"SPAN",{});var Dm=n($a);Sl=r(Dm,"Memory Efficient Attention"),Dm.forEach(s),Gn.forEach(s),un=m(e),F=o(e,"P",{});var fs=n(F);ql=r(fs,"Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),vt=o(fs,"A",{href:!0,rel:!0});var Sm=n(vt);xl=r(Sm,"code"),Sm.forEach(s),Nl=r(fs,", "),bt=o(fs,"A",{href:!0,rel:!0});var qm=n(bt);Ul=r(qm,"paper"),qm.forEach(s),Il=r(fs,"."),fs.forEach(s),cn=m(e),Wt=o(e,"P",{});var xm=n(Wt);Cl=r(xm,"Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),xm.forEach(s),dn=m(e),Re=o(e,"TABLE",{});var zn=n(Re);Ea=o(zn,"THEAD",{});var Nm=n(Ea);oe=o(Nm,"TR",{});var ms=n(oe);ja=o(ms,"TH",{});var Um=n(ja);Vl=r(Um,"GPU"),Um.forEach(s),Fl=m(ms),ka=o(ms,"TH",{});var Im=n(ka);Rl=r(Im,"Base Attention FP16"),Im.forEach(s),Ml=m(ms),Ta=o(ms,"TH",{});var Cm=n(Ta);Gl=r(Cm,"Memory Efficient Attention FP16"),Cm.forEach(s),ms.forEach(s),Nm.forEach(s),zl=m(zn),E=o(zn,"TBODY",{});var T=n(E);ne=o(T,"TR",{});var hs=n(ne);Pa=o(hs,"TD",{});var Vm=n(Pa);Hl=r(Vm,"NVIDIA Tesla T4"),Vm.forEach(s),Ol=m(hs),Aa=o(hs,"TD",{});var Fm=n(Aa);Bl=r(Fm,"3.5it/s"),Fm.forEach(s),Ll=m(hs),Da=o(hs,"TD",{});var Rm=n(Da);Xl=r(Rm,"5.5it/s"),Rm.forEach(s),hs.forEach(s),Yl=m(T),ie=o(T,"TR",{});var us=n(ie);Sa=o(us,"TD",{});var Mm=n(Sa);Wl=r(Mm,"NVIDIA 3060 RTX"),Mm.forEach(s),Kl=m(us),qa=o(us,"TD",{});var Gm=n(qa);Ql=r(Gm,"4.6it/s"),Gm.forEach(s),Jl=m(us),xa=o(us,"TD",{});var zm=n(xa);Zl=r(zm,"7.8it/s"),zm.forEach(s),us.forEach(s),ep=m(T),re=o(T,"TR",{});var cs=n(re);Na=o(cs,"TD",{});var Hm=n(Na);tp=r(Hm,"NVIDIA A10G"),Hm.forEach(s),sp=m(cs),Ua=o(cs,"TD",{});var Om=n(Ua);ap=r(Om,"8.88it/s"),Om.forEach(s),op=m(cs),Ia=o(cs,"TD",{});var Bm=n(Ia);np=r(Bm,"15.6it/s"),Bm.forEach(s),cs.forEach(s),ip=m(T),le=o(T,"TR",{});var ds=n(le);Ca=o(ds,"TD",{});var Lm=n(Ca);rp=r(Lm,"NVIDIA RTX A6000"),Lm.forEach(s),lp=m(ds),Va=o(ds,"TD",{});var Xm=n(Va);pp=r(Xm,"11.7it/s"),Xm.forEach(s),fp=m(ds),Fa=o(ds,"TD",{});var Ym=n(Fa);mp=r(Ym,"21.09it/s"),Ym.forEach(s),ds.forEach(s),hp=m(T),pe=o(T,"TR",{});var _s=n(pe);Ra=o(_s,"TD",{});var Wm=n(Ra);up=r(Wm,"NVIDIA TITAN RTX"),Wm.forEach(s),cp=m(_s),Ma=o(_s,"TD",{});var Km=n(Ma);dp=r(Km,"12.51it/s"),Km.forEach(s),_p=m(_s),Ga=o(_s,"TD",{});var Qm=n(Ga);vp=r(Qm,"18.22it/s"),Qm.forEach(s),_s.forEach(s),bp=m(T),fe=o(T,"TR",{});var vs=n(fe);za=o(vs,"TD",{});var Jm=n(za);gp=r(Jm,"A100-SXM4-40GB"),Jm.forEach(s),yp=m(vs),Ha=o(vs,"TD",{});var Zm=n(Ha);wp=r(Zm,"18.6it/s"),Zm.forEach(s),$p=m(vs),Oa=o(vs,"TD",{});var eh=n(Oa);Ep=r(eh,"29.it/s"),eh.forEach(s),vs.forEach(s),jp=m(T),me=o(T,"TR",{});var bs=n(me);Ba=o(bs,"TD",{});var th=n(Ba);kp=r(th,"A100-SXM-80GB"),th.forEach(s),Tp=m(bs),La=o(bs,"TD",{});var sh=n(La);Pp=r(sh,"18.7it/s"),sh.forEach(s),Ap=m(bs),Xa=o(bs,"TD",{});var ah=n(Xa);Dp=r(ah,"29.5it/s"),ah.forEach(s),bs.forEach(s),T.forEach(s),zn.forEach(s),_n=m(e),Kt=o(e,"P",{});var oh=n(Kt);Sp=r(oh,"To leverage it just make sure you have:"),oh.forEach(s),vn=m(e),R=o(e,"UL",{});var gs=n(R);Ya=o(gs,"LI",{});var nh=n(Ya);qp=r(nh,"PyTorch > 1.12"),nh.forEach(s),xp=m(gs),Wa=o(gs,"LI",{});var ih=n(Wa);Np=r(ih,"Cuda available"),ih.forEach(s),Up=m(gs),Qt=o(gs,"LI",{});var Rp=n(Qt);Jt=o(Rp,"A",{href:!0});var rh=n(Jt);Ip=r(rh,"Installed the xformers library"),rh.forEach(s),Cp=r(Rp,"."),Rp.forEach(s),gs.forEach(s),bn=m(e),d(gt.$$.fragment,e),this.h()},h(){h(y,"name","hf:doc:metadata"),h(y,"content",JSON.stringify(bh)),h(A,"id","memory-and-speed"),h(A,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(A,"href","#memory-and-speed"),h(w,"class","relative group"),h(Ge,"href","https://github.com/facebookresearch/xformers"),h(Ge,"rel","nofollow"),h(wt,"href","xformers"),h(ce,"id","enable-cudnn-autotuner"),h(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ce,"href","#enable-cudnn-autotuner"),h(X,"class","relative group"),h(Oe,"href","https://developer.nvidia.com/cudnn"),h(Oe,"rel","nofollow"),h(_e,"id","use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(_e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(_e,"href","#use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(Y,"class","relative group"),h(Xe,"href","https://huggingface.co/docs/transformers/v4.18.0/en/performance#tf32"),h(Xe,"rel","nofollow"),h(be,"id","half-precision-weights"),h(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(be,"href","#half-precision-weights"),h(W,"class","relative group"),h(ye,"id","sliced-attention-for-additional-memory-savings"),h(ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ye,"href","#sliced-attention-for-additional-memory-savings"),h(K,"class","relative group"),h(kt,"href","/docs/diffusers/pr_2697/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_attention_slicing"),h(Ee,"id","sliced-vae-decode-for-larger-batches"),h(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ee,"href","#sliced-vae-decode-for-larger-batches"),h(Q,"class","relative group"),h(At,"href","/docs/diffusers/pr_2697/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_attention_slicing"),h(Dt,"href","/docs/diffusers/pr_2697/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_xformers_memory_efficient_attention"),h(St,"href","/docs/diffusers/pr_2697/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_vae_slicing"),h(ke,"id","tiled-vae-decode-and-encode-for-large-images"),h(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ke,"href","#tiled-vae-decode-and-encode-for-large-images"),h(J,"class","relative group"),h(Nt,"href","/docs/diffusers/pr_2697/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_attention_slicing"),h(Ut,"href","/docs/diffusers/pr_2697/en/api/pipelines/stable_diffusion/image_variation#diffusers.StableDiffusionImageVariationPipeline.enable_xformers_memory_efficient_attention"),h(It,"href","/docs/diffusers/pr_2697/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_vae_tiling"),h(Vt,"name","sequential_offloading"),h(Pe,"id","offloading-to-cpu-with-accelerate-for-memory-savings"),h(Pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Pe,"href","#offloading-to-cpu-with-accelerate-for-memory-savings"),h(Z,"class","relative group"),h(Rt,"href","/docs/diffusers/pr_2697/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_sequential_cpu_offload"),h(it,"href","https://github.com/huggingface/diffusers/issues/1934"),h(it,"rel","nofollow"),h(zt,"name","model_offloading"),h(qe,"id","model-offloading-for-fast-inference-and-memory-savings"),h(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(qe,"href","#model-offloading-for-fast-inference-and-memory-savings"),h(ee,"class","relative group"),h(Ht,"href","#sequential_offloading"),h(Ue,"id","using-channels-last-memory-format"),h(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ue,"href","#using-channels-last-memory-format"),h(te,"class","relative group"),h(Ie,"id","tracing"),h(Ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ie,"href","#tracing"),h(se,"class","relative group"),h(Fe,"id","memory-efficient-attention"),h(Fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Fe,"href","#memory-efficient-attention"),h(ae,"class","relative group"),h(vt,"href","https://github.com/HazyResearch/flash-attention"),h(vt,"rel","nofollow"),h(bt,"href","https://arxiv.org/pdf/2205.14135.pdf"),h(bt,"rel","nofollow"),h(Jt,"href","xformers")},m(e,l){t(document.head,y),p(e,u,l),p(e,w,l),t(w,A),t(A,$),_(k,$,null),t(w,On),t(w,ys),t(ys,Bn),p(e,Za,l),p(e,S,l),t(S,Ln),t(S,ws),t(ws,Xn),t(S,Yn),t(S,Ge),t(Ge,Wn),t(S,Kn),t(S,wt),t(wt,Qn),t(S,Jn),p(e,eo,l),p(e,$t,l),t($t,Zn),p(e,to,l),p(e,ue,l),t(ue,$s),t($s,M),t(M,so),t(M,ei),t(M,Es),t(Es,ti),t(M,si),t(M,js),t(js,ai),t(ue,oi),t(ue,j),t(j,G),t(G,ks),t(ks,ni),t(G,ii),t(G,Ts),t(Ts,ri),t(G,li),t(G,Ps),t(Ps,pi),t(j,fi),t(j,z),t(z,As),t(As,mi),t(z,hi),t(z,Ds),t(Ds,ui),t(z,ci),t(z,Ss),t(Ss,di),t(j,_i),t(j,H),t(H,qs),t(qs,vi),t(H,bi),t(H,xs),t(xs,gi),t(H,yi),t(H,Ns),t(Ns,wi),t(j,$i),t(j,O),t(O,Us),t(Us,Ei),t(O,ji),t(O,Is),t(Is,ki),t(O,Ti),t(O,Cs),t(Cs,Pi),t(j,Ai),t(j,B),t(B,Vs),t(Vs,Di),t(B,Si),t(B,Fs),t(Fs,qi),t(B,xi),t(B,Rs),t(Rs,Ni),t(j,Ui),t(j,L),t(L,Ms),t(Ms,Ii),t(L,Ci),t(L,Gs),t(Gs,Vi),t(L,Fi),t(L,zs),t(zs,Ri),p(e,ao,l),p(e,Et,l),t(Et,Mi),p(e,oo,l),p(e,X,l),t(X,ce),t(ce,Hs),_(ze,Hs,null),t(X,Gi),t(X,Os),t(Os,zi),p(e,no,l),p(e,He,l),t(He,Oe),t(Oe,Hi),t(He,Oi),p(e,io,l),p(e,de,l),t(de,Bi),t(de,Bs),t(Bs,Li),t(de,Xi),p(e,ro,l),_(Be,e,l),p(e,lo,l),p(e,Y,l),t(Y,_e),t(_e,Ls),_(Le,Ls,null),t(Y,Yi),t(Y,Xs),t(Xs,Wi),p(e,po,l),p(e,ve,l),t(ve,Ki),t(ve,Xe),t(Xe,Qi),t(ve,Ji),p(e,fo,l),_(Ye,e,l),p(e,mo,l),p(e,W,l),t(W,be),t(be,Ys),_(We,Ys,null),t(W,Zi),t(W,Ws),t(Ws,er),p(e,ho,l),p(e,U,l),t(U,tr),t(U,Ks),t(Ks,sr),t(U,ar),t(U,Qs),t(Qs,or),t(U,nr),p(e,uo,l),_(Ke,e,l),p(e,co,l),_(ge,e,l),p(e,_o,l),p(e,K,l),t(K,ye),t(ye,Js),_(Qe,Js,null),t(K,ir),t(K,Zs),t(Zs,rr),p(e,vo,l),p(e,jt,l),t(jt,lr),p(e,bo,l),_(we,e,l),p(e,go,l),p(e,$e,l),t($e,pr),t($e,kt),t(kt,fr),t($e,mr),p(e,yo,l),_(Je,e,l),p(e,wo,l),p(e,Tt,l),t(Tt,hr),p(e,$o,l),p(e,Q,l),t(Q,Ee),t(Ee,ea),_(Ze,ea,null),t(Q,ur),t(Q,ta),t(ta,cr),p(e,Eo,l),p(e,Pt,l),t(Pt,dr),p(e,jo,l),p(e,I,l),t(I,_r),t(I,At),t(At,vr),t(I,br),t(I,Dt),t(Dt,gr),t(I,yr),p(e,ko,l),p(e,je,l),t(je,wr),t(je,St),t(St,$r),t(je,Er),p(e,To,l),_(et,e,l),p(e,Po,l),p(e,qt,l),t(qt,jr),p(e,Ao,l),p(e,J,l),t(J,ke),t(ke,sa),_(tt,sa,null),t(J,kr),t(J,aa),t(aa,Tr),p(e,Do,l),p(e,xt,l),t(xt,Pr),p(e,So,l),p(e,C,l),t(C,Ar),t(C,Nt),t(Nt,Dr),t(C,Sr),t(C,Ut),t(Ut,qr),t(C,xr),p(e,qo,l),p(e,Te,l),t(Te,Nr),t(Te,It),t(It,Ur),t(Te,Ir),p(e,xo,l),_(st,e,l),p(e,No,l),p(e,Ct,l),t(Ct,Cr),p(e,Uo,l),p(e,Vt,l),p(e,Io,l),p(e,Z,l),t(Z,Pe),t(Pe,oa),_(at,oa,null),t(Z,Vr),t(Z,na),t(na,Fr),p(e,Co,l),p(e,Ft,l),t(Ft,Rr),p(e,Vo,l),p(e,Ae,l),t(Ae,Mr),t(Ae,Rt),t(Rt,Gr),t(Ae,zr),p(e,Fo,l),_(ot,e,l),p(e,Ro,l),p(e,Mt,l),t(Mt,Hr),p(e,Mo,l),p(e,De,l),t(De,Or),t(De,ia),t(ia,Br),t(De,Lr),p(e,Go,l),_(Se,e,l),p(e,zo,l),p(e,Gt,l),t(Gt,Xr),p(e,Ho,l),_(nt,e,l),p(e,Oo,l),p(e,D,l),t(D,ra),t(ra,Yr),t(D,Wr),t(D,la),t(la,Kr),t(D,Qr),t(D,pa),t(pa,Jr),t(D,Zr),t(D,it),t(it,el),t(D,tl),p(e,Bo,l),p(e,zt,l),p(e,Lo,l),p(e,ee,l),t(ee,qe),t(qe,fa),_(rt,fa,null),t(ee,sl),t(ee,ma),t(ma,al),p(e,Xo,l),p(e,lt,l),t(lt,Ht),t(Ht,ol),t(lt,nl),p(e,Yo,l),p(e,V,l),t(V,il),t(V,ha),t(ha,rl),t(V,ll),t(V,ua),t(ua,pl),t(V,fl),p(e,Wo,l),p(e,Ot,l),t(Ot,ml),p(e,Ko,l),p(e,xe,l),t(xe,hl),t(xe,ca),t(ca,ul),t(xe,cl),p(e,Qo,l),_(pt,e,l),p(e,Jo,l),p(e,Bt,l),t(Bt,dl),p(e,Zo,l),_(ft,e,l),p(e,en,l),_(Ne,e,l),p(e,tn,l),p(e,te,l),t(te,Ue),t(Ue,da),_(mt,da,null),t(te,_l),t(te,_a),t(_a,vl),p(e,sn,l),p(e,Lt,l),t(Lt,bl),p(e,an,l),p(e,Xt,l),t(Xt,gl),p(e,on,l),_(ht,e,l),p(e,nn,l),p(e,se,l),t(se,Ie),t(Ie,va),_(ut,va,null),t(se,yl),t(se,ba),t(ba,wl),p(e,rn,l),p(e,Ce,l),t(Ce,$l),t(Ce,ga),t(ga,El),t(Ce,jl),p(e,ln,l),p(e,Yt,l),t(Yt,kl),p(e,pn,l),_(ct,e,l),p(e,fn,l),p(e,Ve,l),t(Ve,Tl),t(Ve,ya),t(ya,Pl),t(Ve,Al),p(e,mn,l),_(dt,e,l),p(e,hn,l),p(e,ae,l),t(ae,Fe),t(Fe,wa),_(_t,wa,null),t(ae,Dl),t(ae,$a),t($a,Sl),p(e,un,l),p(e,F,l),t(F,ql),t(F,vt),t(vt,xl),t(F,Nl),t(F,bt),t(bt,Ul),t(F,Il),p(e,cn,l),p(e,Wt,l),t(Wt,Cl),p(e,dn,l),p(e,Re,l),t(Re,Ea),t(Ea,oe),t(oe,ja),t(ja,Vl),t(oe,Fl),t(oe,ka),t(ka,Rl),t(oe,Ml),t(oe,Ta),t(Ta,Gl),t(Re,zl),t(Re,E),t(E,ne),t(ne,Pa),t(Pa,Hl),t(ne,Ol),t(ne,Aa),t(Aa,Bl),t(ne,Ll),t(ne,Da),t(Da,Xl),t(E,Yl),t(E,ie),t(ie,Sa),t(Sa,Wl),t(ie,Kl),t(ie,qa),t(qa,Ql),t(ie,Jl),t(ie,xa),t(xa,Zl),t(E,ep),t(E,re),t(re,Na),t(Na,tp),t(re,sp),t(re,Ua),t(Ua,ap),t(re,op),t(re,Ia),t(Ia,np),t(E,ip),t(E,le),t(le,Ca),t(Ca,rp),t(le,lp),t(le,Va),t(Va,pp),t(le,fp),t(le,Fa),t(Fa,mp),t(E,hp),t(E,pe),t(pe,Ra),t(Ra,up),t(pe,cp),t(pe,Ma),t(Ma,dp),t(pe,_p),t(pe,Ga),t(Ga,vp),t(E,bp),t(E,fe),t(fe,za),t(za,gp),t(fe,yp),t(fe,Ha),t(Ha,wp),t(fe,$p),t(fe,Oa),t(Oa,Ep),t(E,jp),t(E,me),t(me,Ba),t(Ba,kp),t(me,Tp),t(me,La),t(La,Pp),t(me,Ap),t(me,Xa),t(Xa,Dp),p(e,_n,l),p(e,Kt,l),t(Kt,Sp),p(e,vn,l),p(e,R,l),t(R,Ya),t(Ya,qp),t(R,xp),t(R,Wa),t(Wa,Np),t(R,Up),t(R,Qt),t(Qt,Jt),t(Jt,Ip),t(Qt,Cp),p(e,bn,l),_(gt,e,l),gn=!0},p(e,[l]){const yt={};l&2&&(yt.$$scope={dirty:l,ctx:e}),ge.$set(yt);const Ka={};l&2&&(Ka.$$scope={dirty:l,ctx:e}),we.$set(Ka);const Qa={};l&2&&(Qa.$$scope={dirty:l,ctx:e}),Se.$set(Qa);const Ja={};l&2&&(Ja.$$scope={dirty:l,ctx:e}),Ne.$set(Ja)},i(e){gn||(v(k.$$.fragment,e),v(ze.$$.fragment,e),v(Be.$$.fragment,e),v(Le.$$.fragment,e),v(Ye.$$.fragment,e),v(We.$$.fragment,e),v(Ke.$$.fragment,e),v(ge.$$.fragment,e),v(Qe.$$.fragment,e),v(we.$$.fragment,e),v(Je.$$.fragment,e),v(Ze.$$.fragment,e),v(et.$$.fragment,e),v(tt.$$.fragment,e),v(st.$$.fragment,e),v(at.$$.fragment,e),v(ot.$$.fragment,e),v(Se.$$.fragment,e),v(nt.$$.fragment,e),v(rt.$$.fragment,e),v(pt.$$.fragment,e),v(ft.$$.fragment,e),v(Ne.$$.fragment,e),v(mt.$$.fragment,e),v(ht.$$.fragment,e),v(ut.$$.fragment,e),v(ct.$$.fragment,e),v(dt.$$.fragment,e),v(_t.$$.fragment,e),v(gt.$$.fragment,e),gn=!0)},o(e){b(k.$$.fragment,e),b(ze.$$.fragment,e),b(Be.$$.fragment,e),b(Le.$$.fragment,e),b(Ye.$$.fragment,e),b(We.$$.fragment,e),b(Ke.$$.fragment,e),b(ge.$$.fragment,e),b(Qe.$$.fragment,e),b(we.$$.fragment,e),b(Je.$$.fragment,e),b(Ze.$$.fragment,e),b(et.$$.fragment,e),b(tt.$$.fragment,e),b(st.$$.fragment,e),b(at.$$.fragment,e),b(ot.$$.fragment,e),b(Se.$$.fragment,e),b(nt.$$.fragment,e),b(rt.$$.fragment,e),b(pt.$$.fragment,e),b(ft.$$.fragment,e),b(Ne.$$.fragment,e),b(mt.$$.fragment,e),b(ht.$$.fragment,e),b(ut.$$.fragment,e),b(ct.$$.fragment,e),b(dt.$$.fragment,e),b(_t.$$.fragment,e),b(gt.$$.fragment,e),gn=!1},d(e){s(y),e&&s(u),e&&s(w),g(k),e&&s(Za),e&&s(S),e&&s(eo),e&&s($t),e&&s(to),e&&s(ue),e&&s(ao),e&&s(Et),e&&s(oo),e&&s(X),g(ze),e&&s(no),e&&s(He),e&&s(io),e&&s(de),e&&s(ro),g(Be,e),e&&s(lo),e&&s(Y),g(Le),e&&s(po),e&&s(ve),e&&s(fo),g(Ye,e),e&&s(mo),e&&s(W),g(We),e&&s(ho),e&&s(U),e&&s(uo),g(Ke,e),e&&s(co),g(ge,e),e&&s(_o),e&&s(K),g(Qe),e&&s(vo),e&&s(jt),e&&s(bo),g(we,e),e&&s(go),e&&s($e),e&&s(yo),g(Je,e),e&&s(wo),e&&s(Tt),e&&s($o),e&&s(Q),g(Ze),e&&s(Eo),e&&s(Pt),e&&s(jo),e&&s(I),e&&s(ko),e&&s(je),e&&s(To),g(et,e),e&&s(Po),e&&s(qt),e&&s(Ao),e&&s(J),g(tt),e&&s(Do),e&&s(xt),e&&s(So),e&&s(C),e&&s(qo),e&&s(Te),e&&s(xo),g(st,e),e&&s(No),e&&s(Ct),e&&s(Uo),e&&s(Vt),e&&s(Io),e&&s(Z),g(at),e&&s(Co),e&&s(Ft),e&&s(Vo),e&&s(Ae),e&&s(Fo),g(ot,e),e&&s(Ro),e&&s(Mt),e&&s(Mo),e&&s(De),e&&s(Go),g(Se,e),e&&s(zo),e&&s(Gt),e&&s(Ho),g(nt,e),e&&s(Oo),e&&s(D),e&&s(Bo),e&&s(zt),e&&s(Lo),e&&s(ee),g(rt),e&&s(Xo),e&&s(lt),e&&s(Yo),e&&s(V),e&&s(Wo),e&&s(Ot),e&&s(Ko),e&&s(xe),e&&s(Qo),g(pt,e),e&&s(Jo),e&&s(Bt),e&&s(Zo),g(ft,e),e&&s(en),g(Ne,e),e&&s(tn),e&&s(te),g(mt),e&&s(sn),e&&s(Lt),e&&s(an),e&&s(Xt),e&&s(on),g(ht,e),e&&s(nn),e&&s(se),g(ut),e&&s(rn),e&&s(Ce),e&&s(ln),e&&s(Yt),e&&s(pn),g(ct,e),e&&s(fn),e&&s(Ve),e&&s(mn),g(dt,e),e&&s(hn),e&&s(ae),g(_t),e&&s(un),e&&s(F),e&&s(cn),e&&s(Wt),e&&s(dn),e&&s(Re),e&&s(_n),e&&s(Kt),e&&s(vn),e&&s(R),e&&s(bn),g(gt,e)}}}const bh={local:"memory-and-speed",sections:[{local:"enable-cudnn-autotuner",sections:[{local:"use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices",title:"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"}],title:"Enable cuDNN auto-tuner"},{local:"half-precision-weights",title:"Half precision weights"},{local:"sliced-attention-for-additional-memory-savings",title:"Sliced attention for additional memory savings"},{local:"sliced-vae-decode-for-larger-batches",title:"Sliced VAE decode for larger batches"},{local:"tiled-vae-decode-and-encode-for-large-images",title:"Tiled VAE decode and encode for large images"},{local:"offloading-to-cpu-with-accelerate-for-memory-savings",title:"Offloading to CPU with accelerate for memory savings"},{local:"model-offloading-for-fast-inference-and-memory-savings",title:"Model offloading for fast inference and memory savings"},{local:"using-channels-last-memory-format",title:"Using Channels Last memory format"},{local:"tracing",title:"Tracing"},{local:"memory-efficient-attention",title:"Memory Efficient Attention"}],title:"Memory and speed"};function gh(N){return hh(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class jh extends lh{constructor(y){super();ph(this,y,gh,vh,fh,{})}}export{jh as default,bh as metadata};
